    % Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
    n=13;
    a=sprand(n,n,0.2)+10*eye(n); % define sparse random matrix
    asave=a;
    full(a);
    a=tridiag(5,-1,10,-2);
    asave=a;
   [n n]=size(a);
%
%   nonsymmetric bordering approach
%
    a=asave;
    tol=0;
    fprintf('\n')
    fprintf('%s  %1.8g  \n',' ... nonsymmetric approximate inverse by bordering, tol =', tol)
    [z,d,w]=aibn(a,tol);
%    inv(asave)-w*inv(d)*z'
    fprintf('%s %1.8g \n','     residual norm for the bordering approach= ', norm(a-inv(z*inv(d)*w')))
    x=ones(n,1);b=asave*x;m1=inv(z')*d*inv(w);m2=eye(n);rtol=1.0d-8;maxit=1000;x0=zeros(n,1);restrt=10;
    [x,flag,relres,iter] = gmr(asave,b,rtol,maxit,restrt,m1,m2,x0);
    fprintf('%s %d %1.8g %d \n','     GMRES/AIBN: flag, rtol, its = ',flag,rtol,iter)
%
%   SPAI
%
    a=asave;
    full(2)
    ninner=3;
    tau=1.0d-16;
    fprintf('\n')
    fprintf('%s  %1.8g %s  %1.8g \n',' ... SPAI (approximate inverse), ninner=', ninner, 'tau =', tau)
    [m]=spai(a,ninner,tau);
    fprintf('%s %1.8g \n','     residual norm(eye(n)-m*a) = ',norm(full(eye(n)-m*a)))
    x=ones(n,1);b=asave*x;m1=inv(m);m2=eye(n);rtol=1.0d-8;maxit=1000;x0=zeros(n,1);restrt=10;
    [x,flag,relres,iter] = gmr(asave,b,rtol,maxit,restrt,m1,m2,x0);
    fprintf('%s %d %1.8g %d \n','     GMRES/SPAI: flag, rtol, its = ',flag,rtol,iter)
%
%  SPD FSAI 
%
    a=asave'*asave;
    pattern_type=1;
    fprintf('\n')
    fprintf('%s %1.8g \n',' ... FSAI SPD approximate inverse, pattern_type =', pattern_type)
    pattern=get_pattern(a,pattern_type);
    [g]=fsai(a,pattern);
    fprintf('%s %1.8g \n','     residual norm = ', norm(a-inv(g'*g)))
    b=ones(n,1);m1=inv(g'*g);m2=eye(n);rtol=1.0d-8;maxit=1000;
    [x,flag,relres,iter]=pcg(a,b,rtol,maxit,m1,m2);
    fprintf('%s %d %1.8g %d\n','     PCG/FSAI: rtol, its = ',flag,rtol,iter)
%
%  nonsymmetric FSAI 
%
    a=asave;
    tol=0;
    pattern_type=1;
    fprintf('\n')
    fprintf('%s %1.8g \n',' ... nonsymmetric FSAI approximate inverse, pattern_type =', pattern_type)
    pattern=get_pattern(a,pattern_type);
    [gl,gu]=fsai_nonsymmetric(a,pattern);
    fprintf('%s %1.8g \n','     residual norm = ', norm(eye(n)-gl*a*gu))
    x=ones(n,1);b=asave*x;m1=inv(gu*gl);m2=eye(n);rtol=1.0d-8;maxit=1000;x0=zeros(n,1);restrt=10;
    [x,flag,relres,iter] = gmr(asave,b,rtol,maxit,restrt,m1,m2,x0);
    fprintf('%s %d %1.8g %d \n','     GMRES/FSAI: flag, rtol, its = ',flag,rtol,iter)
%
%   AINV (left-looking)
%
    a=asave'*asave;
    tol=0.1;
    fprintf('\n')
    fprintf('%s   %1.8g \n',' ... AINV (left-looking), tol =', tol)
    [z,d]=ainvl(a,tol);
    fprintf('%s %1.8g \n','     residual norm = ', norm(a-inv(z*inv(d)*z')))
    b=ones(n,1);m1=inv(z')*d;m2=inv(z);rtol=1.0d-8;maxit=1000;
    [x,flag,relres,iter]=pcg(a,b,rtol,maxit,m1,m2);
    fprintf('%s %d %1.8g %d\n','     PCG: rtol, its = ',flag,rtol,iter)

%
%   AINV (right-looking)
%
    a=asave'*asave;
    tol=0.1;
    fprintf('\n')
    fprintf('%s   %1.8g \n',' ... AINV (right-looking), tol =', tol)
    [z,d]=ainvr(a,tol);
    fprintf('%s %1.8g \n','     residual norm = ', norm(a-inv(z*inv(d)*z')))
    b=ones(n,1);m1=inv(z')*d;m2=inv(z);rtol=1.0d-8;maxit=1000;
    [x,flag,relres,iter]=pcg(a,b,rtol,maxit,m1,m2);
    fprintf('%s %d %1.8g %d\n','     PCG: rtol, its = ',flag,rtol,iter)

%
%   nonsymmetric AINV (right-looking)
%
    a=asave;
    tol=0.0;
    fprintf('\n')
    fprintf('%s   %1.8g \n',' ... nonsymmetric AINV (right-looking), tol =', tol)
    [z,d,w]=ainvnr(a,tol);
    fprintf('%s %1.8g \n','     residual norm = ', norm(a-inv(w*inv(d)*z')))
    x=ones(n,1);b=asave*x;m1=inv(z')*d*inv(w);m2=eye(n);rtol=1.0d-8;maxit=1000;x0=zeros(n,1);restrt=10;
    [x,flag,relres,iter] = gmr(asave,b,rtol,maxit,restrt,m1,m2,x0);
    fprintf('%s %d %1.8g %d \n','     GMRES/AIBN: flag, rtol, its = ',flag,rtol,iter)
%
%   SAINV (right-looking)
%
    a=asave'*asave;
    tol=0.2;
    fprintf('\n')
    fprintf('%s   %1.8g \n',' ... SAINV (right-looking), tol =', tol)
    [z,d]=sainvr(a,tol);
    fprintf('%s %1.8g \n','     residual norm = ', norm(a-inv(z*inv(d)*z')))
    b=ones(n,1);m1=inv(z')*d;m2=inv(z);rtol=1.0d-8;maxit=1000;
    [x,flag,relres,iter]=pcg(a,b,rtol,maxit,m1,m2);
    fprintf('%s %d %1.8g %d\n','     PCG: rtol, its = ',flag,rtol,iter)
%
% AINV (left-looking, square-root)
%
    a=asave'*asave;
    tol=0.01;
    fprintf('\n')
    fprintf('%s   %1.8g \n',' ... AINV (left-looking, square-root), tol =', tol)
    [z]=ainvl2(a,tol);
    fprintf('%s %1.8g \n','     residual norm = ', norm(a-inv(z*z')))
    b=ones(n,1);m1=inv(z');m2=inv(z);rtol=1.0d-8;maxit=1000;
    [x,flag,relres,iter]=pcg(a,b,rtol,maxit,m1,m2);
    fprintf('%s %d %1.8g %d\n','     PCG: rtol, its = ',flag,rtol,iter)

