    % Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
    fprintf('%s \n',' ... reading matrix ')
    matrix_type=2;  % matrix_type = 1 HB matrix, matrix_type = 2 poisson etc.
    [a,xe,rhs,name]=getmat(matrix_type);
%   a=a(1:418,1:418);
%   a=a(1:6,1:6);
    n=8;
    a=sprand(n,n,0.5)+10*eye(n); % define sparse random matrix
    full(a)
%   a=a(1:6,1:6);
%   a=tril(a)
    rcond(full(a))
    [m n]=size(a);
    fprintf('%s %s \n','     matrix name: ',name)
    fprintf('%s %1.8g  %1.8g \n','     matrix dimensions: ',m,n)
    %
    % transform to CSR (into a structure)
    %
    [ib,jb,ab]=a2csr_m(a);              % transform the matrix a into CSR
    [ia,ja,aa]=a2csr_sparse(a);             % transform the matrix a into CSR
    csra=struct;csra.nrows=n;csra.ncols=n;csra.ia=ia;csra.ja=ja;csra.aa=aa;
    fprintf('%s \n',' ... testing symmetry ')
    [sindex,assindex]=symmetry_index_dense(a);
    fprintf('%s %1.8g \n','     (structural) symmetry index = ',sindex)
    fprintf('%s %1.8g \n','     numerical assymetry index = ',assindex)
    [iat,jat,aat]=trancs(n,n,ia,ja,aa); % transposed a by rows
    csrat=struct;csrat.nrows=n;csrat.ncols=n;csrat.ia=iat;csrat.ja=jat;csrat.aa=aat;
    [sindex,assindex]=symmetry_index_CSR(csra,csrat);
    fprintf('%s %1.8g \n','     (structural) symmetry index = ',sindex)
    fprintf('%s %1.8g \n','     numerical assymetry index = ',assindex)
%   fprintf('%s \n',' ... full format (for nicer debugging)') 
    fprintf('\n')
    fprintf('%s \n',' ... Jacobi scaling ')
    a=scalej(a);
    asave=a;
    %
    % test DFS
    %
    fprintf('\n')
    fprintf('%s \n',' ... generate a matrix')
    n=6;
    a = sprand(n,n,0.4); % generate a general matrix 
    a=a'; 
    full(a)
    if(figures) 
      figure(1);clf;
      G = digraph(a,'omitselfloops')
      plot(G,'Layout','layered')
    end
    %
    % find a reachable set (for fun; includes starting vertex)
    %
    i=1;
    [ia ja aa]=a2csr(a);
    [reach] = find_reach(i,n,ia,ja)
    fprintf('\n')
    fprintf('%s \n',' ... reachable set found ')
    %
    % depth-first search
    %
    v=dfsearch(G,1);
    [preord,postord] = dfs_recursive(n,ia,ja)
    fprintf('\n')
    fprintf('%s \n',' ... DFS performed ')

