    % Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
    n=19;
    a=sprand(n,n,0.8)+n*eye(n); % define sparse random matrix
%    a=poisson(2);
%    a=full(a)
%    a=a(1:3,1:3)
    [n n]=size(a);
    asave=a
    %
    % basic sparse LU
    %
    fprintf('\n')
    fprintf('%s  %1.8g \n',' ... LU kij semisparse ')
%    a=sparse(a)
    [l u]=lu(a);  % matlab stuff (for comparison)
    [l u]=lu_kij_semisparse(a);
    fprintf('%s %1.8g \n','     kij semisparse LU: residual norm(a-l*u) = ',norm(full(asave-l*u)))
    [l u]=lu_kij(a);
    fprintf('%s %1.8g \n','     kij another semisparse LU: residual norm(a-l*u) = ',norm(full(asave-l*u)))
    %
    % find the nonsymmetric elimination tree 
    %
    a1=[1 0 1 0 0 0 0 0 0 0;
       1 1 0 0 1 0 0 1 0 1;
       1 0 1 1 0 0 0 0 0 0;
       0 0 1 1 0 0 0 0 1 1;
       0 0 1 1 1 0 0 1 0 0;
       0 1 0 0 0 1 0 0 0 0;
       0 0 0 1 0 0 1 0 0 0; 
       1 1 1 0 0 0 0 1 0 0;
       0 0 0 0 0 0 0 0 1 1;
       0 0 0 0 1 0 1 0 0 1];
    %
    % test matrix
    %
    a=[1 0 1 0 0 0 0 0 0 0;
       1 1 0 0 1 0 0 1 0 1;
       1 0 1 1 0 0 0 0 0 0;
       0 0 1 1 0 0 0 0 1 1;
       0 0 0 1 1 1 0 1 0 0;
       0 1 0 0 0 1 0 0 0 0;
       0 0 0 1 0 0 1 0 0 0; 
       1 1 1 0 0 0 0 1 0 0;
       0 0 0 0 0 0 0 0 1 1;
       0 0 0 0 1 0 1 0 0 1];
     a
     %
     % find the fill-in (simple inefficient way)
     %
     [n n]=size(a);
     afill=find_fill_a(a);
     a=a+n*eye(n);  
     [ia,ja,aa]=a2csr(a);
  %
  %  find the nonsymetric elimination tree of A
  %
     [parent]=etreen_a(n,a);
  %
  % weighted bipartite matching
  %
     n=25
     a = sprand(n,n,0.6)+0.005*diag(diag(rand(n,n)));
%     a=[ 1 0 3 0 6; 2 0 0 4 4; 5 6 0 1 0; 2 3 0 0 0; 5 7 3 1 1];
     full(a)
%     perm=[ 6  4  11  8  14  9  7  3  1 5 15 2 13 12 10];
%     a=a(:,perm)

     [rperm, cperm, scalr, scalc]=find_strong_diagonal(a);
%     [rperm cperm u v srank] = bpmatch_a_la_mc64(a)
     P=zeros(n,n);
     for i=1:n
       P(rperm(i),cperm(i))=1;
     end


