    % Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
    %
    %  AMD 
    %
    n=145;
    a=sprand(n,n,0.01)+10*eye(n); % define sparse random matrix
    a=a+a';
    asave=a;
    a=asave;
    A=a;
    omat
    fprintf('\n')
    fprintf('%s %1.8g \n',' ... Approximate minimum degree ')
    [p] = amd(a);
    if(figures) 
      figure(5);clf;
      G = graph(a,'omitselfloops');
      plot(G,'Layout','layered');
      figure(6);clf;
      l=chol(a);
      spy(l+l')
      figure(7);clf;
      p=amd(a);
      l=chol(a(p,p));
      spy(l+l')
    end
    fprintf('%s %d %1.8g %d \n','     Approximate minimum degree on a^T+a: fill-in (visible in figure)')
    %
    %  SYMAMD 
    %
    a=asave;
    fprintf('\n')
    fprintf('%s %1.8g \n',' ... Approximate minimum degree ')
    [p] = symamd(a);
    if(figures) 
      figure(8);clf;
      G = graph(a,'omitselfloops');
      plot(G,'Layout','layered');
      figure(9);clf;
      l=chol(a);
      spy(l+l')
      figure(10);clf;
      p=amd(a);
      l=chol(a(p,p));
      spy(l+l')
    end
    fprintf('%s %d %1.8g %d \n','     Approximate minimum degree on a^T+a: fill-in (visible in figure)')
    %
    %  SYMAMD 
    %
    a=asave;
    fprintf('\n')
    fprintf('%s %1.8g \n',' ... CM/RCM profile minimizing strategy ')
    [p] = symrcm(a);
    if(figures) 
      figure(11);clf;
      G = graph(a,'omitselfloops');
      plot(G,'Layout','layered');
      figure(12);clf;
      l=chol(a);
      spy(l+l')
      figure(13);clf;
      l=chol(a(p,p));
      spy(l+l')
    end
    fprintf('%s %d %1.8g %d \n','     CM/RCM (Matlab embedded) profile minimizing strategy: fill-in (visible in figure)')
    %
    %  RCM 
    %
    a=asave;
    %a=poisson(2);
    %a=full(a)
    [ia,ja,aa]=a2csr(a);
    [n n]=size(a);
    [ia ja aa]=remove_diag(n,ia,ja,aa);
    start=1;
    [p] = rcm_gl(start,n,ia,ja,0); % 0: RCM, 1: CM
    if(figures) 
      figure(14);clf;
      G = graph(a,'omitselfloops');
      plot(G,'Layout','layered')
      figure(15);clf;
      l=chol(a);
      spy(l+l')
      figure(16);clf;
      l=chol(a(p,p));
      spy(l+l')
    end
    %
    %  permuting into the SBBD form
    %
    n=10;
    a=sprand(n,n,0.2)+eye(n); % define sparse random matrix
    [n n]=size(a);
    b=a+a';
    if(figures) 
      figure(17);clf;
      G = graph(b,'omitselfloops');
      plot(G,'Layout','layered')
    end
    mask=ones(1,n);
    start=1;
    [ib,jb,ab]=a2csr(b);
    [sepsize separator mask]=find_separator(start,n,ib,jb,mask);
    [ia,ja,aa]=a2csr(a);
    [iat,jat,aat]=a2csr(a');
    [rowblock,columns] = get_sbbd(n,ib,jb,ia,ja,iat,jat,separator,sepsize);
    [p,q] = get_perm_sbbd(n,rowblock,columns);
    fprintf('\n')
    fprintf('%s %1.8g \n',' ... Permutation into SBBD form: permutations found')
    %
    %  Nested dissection
    %
    a=asave;
    a=poisson(20); 
    a=full(a);
    [n n]=size(a);
    [ia,ja,aa]=a2csr(a);
    [ia ja aa]=remove_diag(n,ia,ja,aa);
    [perm]= gnd_gl(n,ia,ja);
    fprintf('\n')
    fprintf('%s %1.8g \n',' ... Nested dissection permutation computed')
    if(figures) 
      figure(18);clf;
      G = graph(b,'omitselfloops');
      plot(G,'Layout','layered')
    end
    l=chol(a(perm,perm));
    spy(l+l')
    stop
