%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% FSAI SPD
%
% function [G] = fsai(A,tol);
%
%
  function [G] = fsai(A,pattern);
  %
  % basic initializations
  %
  a=A;
  [n,n] = size(A);
  G = zeros(n,n);
  %
  % the loop
  %
  for i=1:n
    J=find(pattern(i,1:i) ~= 0); % pattern must contain diagonal entries
    ahat=a(J,J); 
    [nhat nhat]=size(ahat);
    ehat=zeros(nhat,1);ehat(nhat)=1;
    gihat=inv(ahat)*ehat;
    di=1/sqrt(gihat(nhat));
    gi=vector_extend(i,gihat,J);
    di=gi'*a(1:i,1:i)*gi; di=1/sqrt(di); % another way to compute the scaling factor 
    G(i,1:i)=di*gi';
  end

