%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% nonsymmetric FSAI
%
%
  function [GL,GU] = fsai_nonsymmetric(A,pattern);
  %
  % basic initializations
  %
  a=A;
  [n,n] = size(A);
  GL = zeros(n,n);
  GU = zeros(n,n);
  %
  % the loop
  %
  for i=1:n
    JL=find(pattern(i,1:i) ~= 0); % pattern must contain diagonal entries
    JU=find(pattern(1:i,i) ~= 0); % pattern must contain diagonal entries
    ahatl=a(JL,JL); 
    [nhatl nhatl]=size(ahatl);
    ehatl=zeros(nhatl,1);ehatl(nhatl)=1;
    glihat=inv(ahatl')*ehatl;
    gli=vector_extend(i,glihat,JL);
    ahatu=a(JU,JU); 
    [nhatu nhatu]=size(ahatu);
    ehatu=zeros(nhatu,1);ehatu(nhatu)=1;
    guihat=inv(ahatu)*ehatu;
    gui=vector_extend(i,guihat,JU);
    di=gli'*a(1:i,1:i)*gui; 
    GU(1:i,i)=gui*inv(di);
    GL(i,1:i)=gli';
  end

