%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
  function [Z,D] = sainvr(A,tol);

  if (nargin <= 1) tol = 0; end

  [n,n] = size(A);
  Z = eye(n);
  D = eye(n);

  for j=1:n % while i<=n 
%
% pivoting
%
    dj = Z(:,j)'*A*Z(:,j);
%
    for k = j+1:n
      alpha=inv(dj)*Z(:,j)'*A*Z(:,k);
      Z(:,k) = Z(:,k) - alpha*Z(:,j);
      for i=1:j-1
        if(abs(Z(i,k)) < tol)
          Z(i,k)=0.0;
        end
      end
    end

    D(j,j) = dj;
%
% dropping
%

  end


