%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
  %
  % SPAI algorithm (simplified version) 
  %
  function [M] = spai(a,ninner,tau)

  [n n] = size(a);
  E = eye(n);
  M = zeros(n,n);
  for j=1:n  % loop of columns
    J=find(a(:,j) ~= 0);
    for iinner=1:ninner
      I=1:n;  % simplification
      ahat=a(I,J); full(ahat)
      ehat=E(I,j);
      n1=max(size(I));
      n2=max(size(J));
      [Q R]=qr(ahat);
      rhs=Q'*ehat;
      mhat = inv(R(1:n2,1:n2))*rhs(1:n2)   % short solution vector
      m=vector_extend(n,mhat,J)
      r=ehat-ahat*mhat
%if (iinner == 2) huhu, end
      [rmax,ind]=max(abs(r));
      if (abs(r(ind)) < tau) break; end
      if(iinner < ninner) J=union(J,[ind]); end
    end 
    M(J,j) = mhat;
  end
  


