%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% find blocks in a sparse symmetric matrix (Ashcraft)
%
      function  [nc,adjmap] = findbl_ash(n,ia,ja)
%
      null=0;
      vpr=zeros(1,n);
      ivpr=0;
      checksum=zeros(n,1);
      mark=zeros(n,1);
      for i=1:n
        jstrt=ia(i);
        jstop=ia(i+1)-1;
        for j=jstrt:jstop 
          checksum(i)=checksum(i)+ja(j);
        end
      end
      nc=0;
      adjmap=zeros(1,n);
      for i=1:n
        j=adjmap(i);
        jstrt=ia(i);
        jstop=ia(i+1)-1;
        isize=jstop-jstrt;
        if (j == null) % node not added yet
%
          if(isize == 0) % this is an isolated node
            nc=nc+1;
            adjmap(i)=nc;
          else
%
            marked=0; % no marked nodes yet
            for jj=jstrt:jstop
              iend=0;
              kk=ja(jj);
              if(kk < i) 
                if(checksum(kk) == checksum(i)) 
%
%              -- checksums are the same
%
                  kstrt=ia(kk);
                  kstop=ia(kk+1)-1;
                  ksize=kstop-kstrt;
                  if(ksize == isize) 
%
%                -- sizes of adjacent sets are also the same
%                -- now the adjacency sets must be checked
%
                    if(marked == 0) 
                      for j=jstrt:jstop % mark entries from one adjacency set
                        k=ja(j);
                        mark(k)=i;
                      end 
                      marked=1;
                    end 
                    for j=kstrt:kstop
                      k=ja(j);
                      if(mark(k) ~= i) 
                        iend=i;
                      end 
                    end 
%
%                -- adjacent sets are the same
%
                    if (iend ~= i) 
                      adjmap(i)=adjmap(kk); 
                      chk=checksum(kk);
                    end
                  end 
                end 
              end 
              iend=0;
            end
            if(adjmap(i) == null)
              nc=nc+1;
              adjmap(i)=nc;
            end 
          end
        end 
      end 

