%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% find blocks in a sparse symmetric matrix
% an approach based on angles among (binarized) matrix rows
%
      function  [nc,adjmap] = findbl_cos(n,ia,ja,iat,jat,tau)
%
      adjmap=zeros(1,n);
      icosine=zeros(1,n);
%
%  -- initialize the groups
%
      for i=1:n
        icosine(i)=0;
      end 
      ib=0;
%
%  -- start the loop
%
      for  i=1:n
        if(adjmap(i) == 0) 
%
%      -- initialize the block
%
          ib=ib+1;
          adjmap(i)=ib;
          jstrt=ia(i);
          jstop=ia(i+1)-1;
          isize=jstop-jstrt+1;
%
%         compute dot products ai a^t
%
          for jj=jstrt:jstop
            j=ja(jj);
            kstrt=iat(j);
            kstop=iat(j+1)-1;
            for kk=kstrt:kstop
              col=jat(kk);
              if (col > i && adjmap(col)==0) icosine(col)=icosine(col)+1; end
            end 
          end 
%
%      -- create 
%      -- compare integer cosines with block sizes
%
          for k=1:n
            if(icosine(k) ~= 0) 
              ksize=ia(k+1)-ia(k);
              if ((icosine(k)*icosine(k)) >= (tau*tau*isize*ksize)) 
                adjmap(k)=ib;
              end
            end 
            icosine(k)=0;
          end 
        end 
      end 
      nc=ib;
%
