%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
%
% Cholesky factorization by columns
% using block arithmetic
%
  function [l]=ch_columns(a)
%
  [m n]=size(a);
  aorg=a;
  l=eye(n);
  u(1,1)=a(1,1);
  l(1,1)=sqrt(a(1,1));
  l(2:n,1)=a(2:n,1);
  u=zeros(n,n);
  u(1,1)=a(1,1);

  for j=2:n
    z=a(j:n,j)- l(j:n,1:j-1)*[l(j,1:j-1)]';
    l(j,j)=sqrt(z(1));
    l(j+1:n,j)=z(2:n-j+1)/l(j,j);
  end
  