%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
%
    function [ip,jp,ap] = cholesky_ll_sparse_tasks(n,ia,ja,aa)
%
    diagtol=1.0d-15;
    drfl=0;
    max_p=30;
    ip=zeros(1,n+1);
    ip(1)=1;
    listl=zeros(1,n);
    startl=zeros(1,n);
    jp=[]; % jp=zeros(1,max_p);
    ap=[]; % ap=zeros(1,max_p);
%
    flag=0;
    wn01=zeros(1,n);
    wn02=zeros(1,n);
%
     listl=zeros(1,n);

     for j=1:n
      dg=aa(ia(j));
      ind2=0;
      wr01=zeros(1,n);
%
      for ii=ia(j)+1:ia(j+1)-1
        k=ja(ii);
        temp=aa(ii);
        ind2=ind2+1;
        wn02(ind2)=k;
        wn01(k)=ind2;
        wr01(k)=aa(ii) ;
      end 

      lcurr=listl(j);
      while (lcurr ~= 0)
        %
        %  update column j by column lcurr
        %
        [ind2,wn02,wn01,wr01,istrt,istop,dg]=ll_update(ind2,wn02,wn01,wr01,ip,jp,ap,lcurr,startl,dg);

        lnext=listl(lcurr);
        if(istrt <= istop) 
          startl(lcurr)=istrt;
          nextrow=jp(istrt);
          listl(lcurr)=listl(nextrow);
          listl(nextrow)=lcurr;
        end 
        lcurr=lnext;
      end 
%
      wn02=sort(wn02(1:ind2));
      absdiag=sqrt(abs(dg));
      ap(ip(j))=absdiag;
      jp(ip(j))=j;
      ind=ip(j)+1;

%
      [wn01,wr01]=ll_scale(ind2,wn02,wn01,wr01,absdiag); % scaling
      [ind2,wn02,wr01]=ll_drop(ind2,wn02,wr01,drfl,absdiag); % dropping
      [ind,jp,ap,wr01]=ll_move(ind,jp,ap,ind2,wn02,wr01); % moving
      ip(j+1)=ind;
%
      if(ind ~= ip(j)+1) % set up startl pointer for the j-th column
        startl(j)=ip(j)+1;
        lnext=jp(ip(j)+1);
        listl(j)=listl(lnext);
        listl(lnext)=j;
      end 
%
    end

   