%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
%
    function [ip,jp,ap] = ldlt_ll_sparse(n,ia,ja,aa)
%
    diagtol=1.0d-15;
    drfl=0;
    max_p=30;
    wn02=zeros(1,n);
    wr01=zeros(1,n);
    ip=zeros(1,n+1);
    ip(1)=1;
    listl=zeros(1,n);
    startl=zeros(1,n);
    jp=zeros(1,max_p);
    ap=zeros(1,max_p);
%
    flag=0;
    wn01=zeros(1,n);
%
     listl=zeros(1,n);

     for j=1:n
      dg=aa(ia(j));
      ind2=0;
      for ii=ia(j)+1:ia(j+1)-1
        k=ja(ii);
        wr01(k)=aa(ii);
        ind2=ind2+1;
        wn02(ind2)=k;
        wn01(k)=ind2;
      end 

      lcurr=listl(j);
      while (lcurr ~= 0)  
        lnext=listl(lcurr);  % find next column, if it exists
        lcurr;
        jndiag=startl(lcurr);
        ndiag=ap(jndiag);
        temp=ndiag*ap(ip(lcurr));
        dg=dg-ndiag*temp;
        istrt=jndiag+1;
        istop=ip(lcurr+1)-1;
        for ii=istrt:istop
          k=jp(ii);
          if(wn01(k) == 0)
            ind2=ind2+1;
            wn02(ind2)=k;
            wn01(k)=ind2;
          end 
          wr01(k)=wr01(k)-ap(ii)*temp;
        end

        if(istrt <= istop)  % update the starting pointers
          startl(lcurr)=istrt;
          nextrow=jp(istrt);
          listl(lcurr)=listl(nextrow);
          listl(nextrow)=lcurr;
        end 

        lcurr=lnext;
%
      end 
%
      wn02=sort(wn02(1:ind2));
%
      ind=ip(j)+1;
%
      if(ind+ind2 >= max_p) % reallocation (not needed in Matlab)
        incr=max_p;
        jp_work=jp;
        jp=zeros(1,max_p+incr);
        jp(1:max_p)=jp_work(1:max_p);
        ap_work=ap;
        ap=zeros(1,max_p+incr);
        ap(1:max_p)=ap_work(1:max_p);
        max_p=max_p+incr;
        disp 'reallocated'
      end
%
      absdiag=abs(dg);
      if(absdiag < diagtol) 
        imodif=imodif+1;
        dg=diagtol;
      end 
      dg=1.0d0/absdiag;
%
      indold=ind;
      for ii=1:ind2 % drop/shrink
        temp=wr01(wn02(ii));
        wn01(wn02(ii))=0;
        wr01(wn02(ii))=0;
        if(abs(temp) >= drfl) 
          ap(ind)=temp;
          jp(ind)=wn02(ii);
          ind=ind+1;
        end 
      end
      ip(j+1)=ind;
%
      ap(ip(j))=dg;
      jp(ip(j))=j;
%
      if(ind ~= ip(j)+1)
        startl(j)=ip(j)+1;
        lnext=jp(ip(j)+1);
        listl(j)=listl(lnext);
        listl(lnext)=j;
      end 
%
    end

   