%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% multifrontal cholesky
% warning: this code has been created for teaching purposes
%          such codes are very often, intentionally, NOT efficient  (even in matlab :-))
%
%
   %
    function [il,jl,al]=multifrontal_cholesky(n,parent,ia,ja,aa)
    %
    ind=1; % stack counter for the next contribution
    stack_ptri(ind)=1; % intialize pointers for stacks
    stack_ptrs(ind)=1;
    %
    % initialize output
    %
    il(1)=1;
    indl=1;
    for ii=1:n
      fsize=ia(ii+1)-ia(ii);
      f=zeros(fsize,fsize);
      fi=ja(ia(ii):ia(ii+1)-1);
      for j=ia(ii):ia(ii+1)-1
        f(1,1:fsize)=aa(ia(ii):ia(ii+1)-1);
        f(2:fsize,1)=aa(ia(ii)+1:ia(ii+1)-1);
      end
      indc=ind-1; % counter of the last item in the stack
      while indc > 0
       indc
        topi=stack_ptri(indc)
        sizi=stack_size(indc)
        tops=stack_ptrs(indc)
        stacki
        firsti=stacki(topi) % position of the first index of a frontal contribution
        if(firsti == ii) % pop from the stack and redefine f
          addi=stacki(topi:topi+sizi-1)
          add = stacks(tops:tops+sizi*sizi-1)
          add = reshape(add,sizi,sizi)
          [fi f]=extend_add(fi,f,addi,add)
          indc=indc-1;
        else
          break;
        end
      end
      ind=indc+1
      %
      % do one step of elimination
      %
      fsize=max(size(f))
      for i=2:fsize
        for j=2:fsize
          f(i,j)=f(i,j)-f(i,1)*inv(f(1,1))*f(1,j);
        end
      end
      %
      % store a column of L
      %
      d=f(1,1); d=sqrt(d);
      for i=1:fsize
        jl(indl)=fi(i);
        al(indl)=f(i,1)/d;
        indl=indl+1;
      end
      il(ii+1)=indl;
      %
      % put the remaining part of the frontal matrix onto a stack
      % (can be optimized by putting only the triangular part)
      %
      if (fsize > 1) 
        topi=stack_ptri(ind)
        tops=stack_ptrs(ind)
        stack_size(ind)=fsize-1
        ind=ind+1
        stacki(topi:topi+fsize-2)=fi(2:fsize)
        topi=topi+(fsize-1)
        stack_ptri(ind)=topi
        ff=reshape(f(2:fsize,2:fsize),1,(fsize-1)*(fsize-1))
        stacks(tops:tops+(fsize-1)*(fsize-1)-1)=ff
        tops=tops+(fsize-1)*(fsize-1)
        stack_ptrs(ind)=tops
      end
    end


