%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% Simplified sparse left-looking Cholesky
% 
  function [l]=simplified_sparse_left_looking(a)
%
  [n n]=size(a);
  l=zeros(n,n);
  l=tril(a); % simplification that does not prohibit checking for correctness;
  for j=1:n
    for k=1:j-1
      if(l(j,k) ~= 0)
        for i=j:n
          if(l(i,k) ~= 0) 
            l(i,j)=l(i,j)-l(i,k)*l(j,k);
          end
        end
      end
    end
    l(j,j)=sqrt(l(j,j));
    for i=j+1:n
      if(l(i,j) ~= 0)
        l(i,j)=l(i,j)*inv(l(j,j));
      end
    end
  end
 