%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods

    function [ibl,jbl,sbl,al] = super_setup_triangular(n,nsuper,il,jl,ia,ja,aa,snode,ssiz)
    %
    sbl=zeros(1,nsuper+1);
    sbl(1)=1;
    for i=1:nsuper
      sbl(i+1)=sbl(i)+ssiz(i);
    end
    %
    % get counts of indices in the supernodes
    %
    count=0;
    for i=1:nsuper
      lastcol=sbl(i+1)-1;
      off=il(lastcol+1)-il(lastcol)-1;
      % count=count+ssiz(i)*(ssiz(i+1)/2+off*ssiz(i); will not add the triangle - not needed
      count=count+1+off*ssiz(i);
    end
    jbl=zeros(1,count)
    ind=1;
    ibl(1)=1;
    for i=1:nsuper
      jbl(ind)=sbl(i); % our definition
      ind=ind+1;
      lastcol=sbl(i+1)-1;
      for j=il(lastcol)+1:il(lastcol+1)-1;
        jbl(ind)=jl(j);
        ind=ind+1;
      end
      ibl(i+1)=ind;
    end
    %
    % values of A into the supernodal block structure
    %
    indr=1; 
    for i=1:nsuper
      %
      % setup local pointers
      %
      i
      col=sbl(i)
      sstrt=il(col)
      smid=sstrt+ssiz(i)-1
      sstop=il(col+1)-1
      indrold=indr;
      inds=indrold+ssiz(i)*(ssiz(i)+1)/2
      dim_off=(sstop-smid)*ssiz(i)
      al(indrold:inds-1+dim_off)=zeros(1,inds-indrold+dim_off)
      l=1;
      for j=sbl(i):sbl(i+1)-1
        col=j
        sstrt=il(col)
        smid=il(col)+ssiz(i)-l
        sstop=il(col+1)-1
        map=zeros(1,n);
        for jj=il(col):smid
          k=jl(jj);
          map(k)=indr;
          indr=indr+1;
        end
        inds=indrold+ssiz(i)*(ssiz(i)+1)/2+(j-sbl(i))
        for jj=smid+1:sstop
          k=jl(jj);
          map(k)=inds;
          inds=inds+ssiz(i);
        end
        jstrt=ia(j)
        jstop=ia(j+1)-1
        map
        for j=jstrt:jstop
          k=ja(j)
          al(map(k))=aa(j)
          if(k <= sbl(i+1)-1)
            map(k)=map(k)+ssiz(i)-(k-sbl(i));
          else
            map(k)=map(k)+ssiz(i);
          end
        end
        l=l+1;
      end
      indr=indrold+ssiz(i)*(ssiz(i)+1)/2+ dim_off
    end

