%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% get postordering of the elimination tree
%
     function [postord,ipsord]=get_postord(n,parent,son,ison)
%
%
%
% -- initialize wn01 to ison
%
      for i=1:n+1
        wn01(i)=ison(i);
      end 
%
% -- find roots of components
% -- the roots of components have parent(i)=0
% -- or they can have also parent(i).gt.n
% -- jnd denotes number of the roots
%
      jnd=0;
      for i=1:n
        if(parent(i) <= 0 || parent(i) > n)
          jnd=jnd+1;
          wn02(jnd)=i;
        end 
      end 
%
%  -- get the postordering by traversing components
%  -- of the elimination forest
%
      ind=0;
%
      for ii=1:jnd
        i=wn02(ii);
        while (i > 0 && i < n+1)
          j=wn01(i);
          if(j <= ison(i+1)-1) 
            wn01(i)=wn01(i)+1;
            i=son(j);
          else
            ind=ind+1;
            ipsord(i)=ind;
            postord(ind)=i;
            i=parent(i);
          end
        end 
      end 

%
