%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% compute row counts in the Cholesky factor
%
   %
   % compute row counts
   %
     function [row]=rowl_counts(n,parent,ia,ja,aa)
   %
     row=zeros(n,1);
     mark=zeros(n,1);
   %
     for i=1:n
       row(i)=1;
       mark(i)=i;
       jstrt=ia(i);
       jstop=ia(i+1)-1;
       for j=jstrt:jstop
         k=ja(j);
         if(k < i) 
           jj=k;
           while (mark(jj) ~= i)
             row(i)=row(i)+1;
             mark(jj)=i;
             jj=parent(jj);
           end
         end
       end
     end