%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% Cholesky symbolic factorization (Cholesky structure by columns)
%
 
     function [il,jl]=sfact(n,ia,ja,maxl)
%

%
      kstrt=1;
      kstop=0;
      il(1)=1;
      listl=zeros(n,1);
%   
%  -- loop of columns
%
      for k=1:n
        lcount=0;
        jstrt=ia(k);
        jstop=ia(k+1) - 1;
        current(k)=n+1;
%
        for j=jstrt:jstop % insert entries of A, larger than than k, into  a linked list
          jj=ja(j);
          if(jj > k) 
            next=k;
            kcurr=next;
            next=current(kcurr);
            while (next <= jj) 
              kcurr=next;
              next=current(kcurr);
            end 
            lcount=lcount+1;
            current(kcurr)=jj;
            current(jj)=next;
          end 
        end
%
%       insert structures of previous columns of L into the list
%
        i=listl(k);   % i is a son of k
                      % 
        while (i > 0) 
          jstrt=il(i)+1;    % not used position il(i) since it should be the current k
          jstop=il(i+1)-1;  % end of the structure in il
                           % note that il is defined for the column i < k
          next=k;      % we start always at the beginning
          for j=jstrt:jstop
            jj=jl(j);
            kcurr=next; % column sort by indices is expected (result of the algorithm)
            next=current(kcurr);
            while (next < jj) 
              kcurr=next;
              next=current(kcurr);
            end 
            if(next > jj)  % insert jj
              lcount=lcount+1;
              current(kcurr)=jj;
              current(jj)=next;
              next=jj;
            end
          end 
          i=listl(i);  % other sons: listl(listl(i)), ...
        end 
%
%    -- rewrite the complete structure
%
        kstrt=kstop+1;
        kstop=kstop+lcount;
        if (kstop > maxl) % if not - reallocate (in standard languages)
          err=err;
        end
        i=k;
        for j=kstrt:kstop
          i=current(i);
          jl(j)=i;
        end 
        il(k+1)=il(k)+lcount;
%
%    -- set up the pointer for k
%
        if (lcount > 1)  
          i=jl(il(k)); % first off-diagonal
          listl(k)=listl(i);   
          listl(i)=k;  % k is a son of i
        end           
      end 
%
