%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% Cholesky symbolic factorization (Cholesky structure by columns)
%
 
     function [il,jl]=sfact2(n,ia,ja,il,ichild)
%    
     jchild=[];
     nchild=zeros(1,n);
     jl=zeros(1,il(n+1)-1);
     nl=[]; 
     for j=1:n
       ind=il(j);
       for i=ia(j):ia(j+1)-1
         k=ja(i);
         if(k > j)
           jl(ind)=k;
           ind=ind+1;
         end
       end
       nl(j)=ind-il(j);
       indchild=ichild(j);
       for i=indchild:indchild+nchild(j)-1
         k=jchild(i);
         v=merge_index_sets(jl(il(j):il(j)+nl(j)-1),jl(il(k):il(k)+nl(k)-1));
         v=remove_index(v,j);
         [s t]=size(v); s=t; % v is defined as row vector max(s,t);
         jl(il(j):il(j)+t-1)=v;
         nl(j)=t;  
       end
       if(nl(j) ~= 0)
         p=min(jl(il(j):il(j)+nl(j)-1));
         i=nchild(p);
         jchild(ichild(p)+i)=j;
         nchild(p)=nchild(p)+1;
       end
       %
     end
