   %
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
   % test whether a graph is bipartite
   %
   function [bipartite] = is_bipartite(n,ia,ja,aa)
%
   bipartite=0;
   if(n < 2) % graph too small
     bipartite=1; 
   end
   if(ia(n+1)-1 == 0) % graph with no edges
     bipartite=2;
   end
%
   comp=zeros(n,1); % components do no need to be stored
   [ncomp,icomp,jcomp]=find_components(n,ia,ja,aa);
   for i=1:ncomp
     for j=icomp(i):icomp(i+1)-1
        k=jcomp(j);
        comp(k)=i;
     end
   end
%
   flag=zeros(n,1);
   for i=1:ncomp % for each component
     istart=jcomp(icomp(i)); % start in the component icomp(i)
     [nlevel,ilevel,jlevel]=find_levels(istart,flag,n,ia,ja); 
     %
     for ii=1:2:nlevel % every second level is flagged
       for j=ilevel(ii):ilevel(ii+1)-1
         k=jlevel(j);
         flag(k)=-1; % black vertices
       end
     end
     for ii=1:2:nlevel
       for j=ilevel(ii):ilevel(ii+1)-1
         k=jlevel(j);
         for l=ia(k):ia(k+1)-1
           ll=ja(l);
           if(ll ~= k)
             if(flag(ll)==-1)
               bipartite=3;
             end
           end
         end
       end
     end
   end
%