%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% 
% recursive Tarjan algorithm to find strong components
%


  function [ncomp,ic,jc,preord] = scomp_recursive(n,ia,ja)
%
  global ind index preord lowlink onstack stack head ncomp ic jc indc

  head=0;
  ic=[];

  ncomp=0;
  ic(1)=1;
  indc=0;

  index=zeros(1,n);
  preord=zeros(1,n);
%  lowlink=zeros(1,n);
  onstack=zeros(1,n);
  stack=zeros(1,n);


  ind=0;
  for i=1:n
    if index(i)==0
      sconnect(i,ia,ja);
    end
  end


  function sconnect(i,ia,ja)

  global ind index preord lowlink onstack stack head ncomp ic jc indc

  ind=ind+1; 
  index(i)=ind;
  preord(ind)=i;
  lowlink(i)=ind;
  head=head+1;
  stack(head)=i;
  onstack(i)=1;

  for k=ia(i):ia(i+1)-1
    j=ja(k);
    if index(j)==0
      sconnect(j,ia,ja);
      lowlink(i)=min(lowlink(i),lowlink(j));
    elseif onstack(j) == 1
      lowlink(i)=min(lowlink(i),index(j));
    end
  end

  if (lowlink(i) == index(i))
    if head > 0
    while stack(head) ~= i
      indc=indc+1;
      jc(indc)=stack(head);
      onstack(stack(head))=0;
      head=head-1;
    end
    indc=indc+1;
    jc(indc)=stack(head);
    onstack(stack(head))=0;
    head=head-1;
    ncomp=ncomp+1;
    ic(ncomp+1)=indc+1;
    end
  end
  

        
