%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% finding strong components of a graph (given in ia,ja)
% based on Tarjan, 1972, p.157
% recursive version that uses an explicit stack
% based on DFS with lowlink info
%
    function [ncomp,ic,jc]=scomp_recursive2(n,ia,ja)
%
    s=zeros(n,1);
    pointer=0;
    index=1;
    ncomp=0;
    ic(1)=1;
    jc=[];
    icomp=1;
    mark=zeros(n,1);
    lowlink=zeros(n,1);
    is_onstack=zeros(n,1);
    for i=1:n
      if(mark(i) == 0)
        [ncomp,icomp,ic,jc,mark,lowlink,is_onstack,index,s,pointer]=sc(i,n,mark,lowlink,is_onstack,index,s,pointer,ia,ja,ncomp,icomp,ic,jc);
      end
    end

    function [ncomp,icomp,ic,jc,mark,lowlink,is_onstack,index,s,pointer]=sc(v,n,mark,lowlink,is_onstack,index,s,pointer,ia,ja,ncomp,icomp,ic,jc)
    v;
    mark(v)=index;
    lowlink(v)=index;
    index=index+1;
    pointer=pointer+1;
    s(pointer)=v;
    is_onstack(v)=1;
    for j=ia(v):ia(v+1)-1
      w=ja(j);
      if(w ~= v)
        if (mark(w) == 0) 
          [ncomp,icomp,ic,jc,mark,lowlink,is_onstack,index,s,pointer]=sc(w,n,mark,lowlink,is_onstack,index,s,pointer,ia,ja,ncomp,icomp,ic,jc);
          lowlink(v)=min(lowlink(v),lowlink(w));
        elseif(is_onstack(w) == 1)
          lowlink(v)=min(lowlink(v),mark(w));
        end
      end
    end

    if(lowlink(v) == mark(v))
v;
lowlink(v);
mark(v);
s;
pointer;
      ncomp=ncomp+1;
      k=s(pointer);
      while (k ~= v) 
        pointer=pointer-1;
        is_onstack(k) = 0;
        jc(icomp)=k;
        icomp=icomp+1;
        k=s(pointer);
      end
      pointer=pointer-1;
      is_onstack(v) = 0;
      jc(icomp)=v;
      icomp=icomp+1;
      ic(ncomp+1)=icomp; 
    end


