%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% IC(0) right looking - Cholesky
%
  function [l,nonpos] = ic0a(a)

  nonpos=0;
  [n n] = size(a);
  l = tril(a);
  for k = 1:n
    if (l(k,k) <= 0) nonpos=1; break; end
    l(k,k) = sqrt(l(k,k)); 
    for i = k+1:n          
      if (l(i,k) ~= 0)
        l(i,k) = l(i,k) / l(k,k);
      end
      for j = k+1:i
        if (l(i,j) ~= 0)
          l(i,j) = l(i,j) - l(i,k)*l(j,k);
        end
      end
    end
  end

