%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% left looking Cholesky (Crout variant)
% experimental code (S1, S2)
%
%  mode: = 0: standard (S1)
%        = 1: up_looking-based (S2)
%
  function [l]=icl2(a,tau,mode)
  %
  % basic initializations   
  % 
  a=full(a);                  
  A=a;
  [n,n]=size(a);
  %
  % sloupcova formulace (jik rozklad)
  %
  l=zeros(n,n);
  l(1,1)=sqrt(a(1,1));
 
%
  for j=1:n
    %
    % compute row pattern 
    %
    l(j:n,j)=a(j:n,j);
    if(mode == 0) % use S_1
      n_row=0;
      for k=1:j-1
        if(abs(l(j,k)) > tau) n_row=n_row+1; jrow(n_row)=k; row(n_row)=l(j,k); end
      end 
    else % use_S2
      b=a(1:j-1,j); row=inv(l(1:j-1,1:j-1))*b;
      n_row=0;
      for k=1:j-1
        if(row(k) ~= 0) n_row=n_row+1; jrow(n_row)=k; row(n_row)=row(k); end
      end
    end
    %
    for ii=1:n_row
      k=jrow(ii);  
      temp=row(ii);
      for i=j:n
        l(i,j)=l(i,j)-l(i,k)*temp;
      end
    end
    %
    l(j,j)=sqrt(l(j,j));
    %
    % scale column j to get a column of L
    %
    for i=j+1:n
      l(i,j)=l(i,j)/l(j,j);
      if(abs(l(i,j)) < tau) l(i,j)=0; end
    end
    %
  end

%
