%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% simple IC by levels
%
  function L=iclevel(A,ilev)
%
% assume SPD matrix A
%
  [n,n]=size(A);
%
% initialize levels
%
  a=A;
  for i=1:n
    for j=1:n
      level(i,j)=n+1;
    end
  end
  for i=1:n
    for j=1:n
      if(a(i,j) ~= 0) 
        level(i,j)=0;
      end
      if(i == j) 
        level(i,j)=0;
      end
    end
  end
%
  for i=1:n
    for k=1:i-1
      if(level(i,k) <= ilev)
        a(i,k)=a(i,k)/a(k,k);
        for j=k+1:n
          a(i,j)=a(i,j)-a(i,k)*a(k,j);
          level(i,j)=min(level(i,j),level(i,k)+level(k,j)+1);
        end
      end
    end
    for j=1:n
      if(level(i,j) > ilev)
        a(i,j)=0;
      end
    end
  end
  D=diag(diag(a));
  L=tril(a)-D+eye(n);
  U=triu(a);
%
% if SPD we can do it
%
  d=sqrt(D);
  L=L*d;
  U=inv(d)*U;
