%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% left looking Cholesky / LDL'  
% with inverse-based estimation
%
  function [l,d]=iclid(A,drfl)
  %
  % basic initializations   
  % 
  A=full(A);                  
  [n,n]=size(A);
  a=A;
%
  l=eye(n);
  d=eye(n);
%
% v uses updates
% v2 is without updates
%
  v=zeros(n,1);
  vplus=zeros(n,1);
  vminus=zeros(n,1);
  v2=zeros(n,1);
  vplusnorm=0;
  vminusnorm=0;
  etal=0;
  vnorm=0;
%
% sloupcova formulace (jik rozklad)
%
  l=eye(n);
  d(1,1)=a(1,1);
  rnormest=zeros(n,1);
 
%
  for j=1:n
%
    j;
    for k=1:j-1
      for i=j:n
        a(i,j)=a(i,j)-l(i,k)*d(k,k)*l(j,k);
      end
    end
    d(j,j)=a(j,j);
    %
    % scale column j to get a column of L
    %
    for i=j:n
      l(i,j)=a(i,j)/d(j,j);
    end
    l;
    %
    dropvar=1;
    l;
    [v,vnorm,vplus,vminus,vplusnorm,vminusnorm,etal]= ...
      triest(n,j,l,v,vnorm,vplus,vminus,dropvar);
    rnormest(j)=etal;
    etal;
    etall=drfl/max(1,etal);
    etall;
    for i=j+1:n
      if(abs(l(i,j)) < etall) 
        l(i,j)=0;
      else
        i;
        j;
        l(i,j);
      end
    end
    vv=l(1:n,j);
%
end
l*d*l';
%
% compute exact row norms of inv(l)
%
  rnorm=zeros(n,1);
  invl=inv(l);
  for i=1:n
    rnorm(i)=norm(invl(i,1:i),1);
  end 
%
% compare exact and estimated norms of rows if inv(l)
%
  norm(rnorm-rnormest);
  rnormest;
  rnorm;
%
%disp('norm A-l*d*l'); 
nor=norm(A-l*d*l');
%
