
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% ic right-looking decomposition.
%
% history:
%   the code by Mirek Tuma, Prague, 19/11/2005.
%
  function [l]=icr_chol(A)
  %
  % basic initializations   
  %                   
  [n,n]=size(A);
  a=A;
  %
  % define the sparsity pattern for ic(0)
  %                   
  pattern=eye(n);
  pattern=( abs(A) > 0 );
  b=ones(n,n);
  %
  % initialize l,d
  %
  d=sparse(eye(n));
%
% submaticova formulace (kij rozklad)
%
l=tril(a);
for k=1:n
  d(k,k)=sqrt(l(k,k));
  for i=k:n
    l(i,k)=l(i,k)/d(k,k);
  end
  for j=k+1:n
    for i=j:n
      if(b(i,j) ~= 0)
        l(i,j)=l(i,j)-l(i,k)*l(j,k);
      end;
    end
  end
 end
%
norm(a-l*l',inf);
%
