%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% MIC(0): right looking version
%
  function [l,d]=mic0(a)
  %
  % basic initializations   
  %                   
  [m n]=size(a);
  if(m ~= n) error; end 
  rowsumsa=row_pattern_sums(a,a); % test - before destroying the matrix inside the algorithm

  %
  % initialize l,d
  %
  l=sparse(eye(n));
  d=sparse(eye(n));
  %
  % submatrix algorithm (kij)
  %
  for k=1:n
    d(k,k)=a(k,k);
    for i=k+1:n
      l(i,k)=a(i,k)/d(k,k);
    end
    for i=k+1:n
      for j=k+1:n
        if(a(i,j) ~= 0)
          a(i,j)=a(i,j)-l(i,k)*a(k,j);
        else
          a(i,i)=a(i,i)-l(i,k)*a(k,j);
        end;
      end
    end
   end

   fulll=full(l);
   fullproduct=full(l*d*l');
   fprintf('%s %1.8g \n','     MIC(0): difference in row counts A, M (at prescribed positions) = ',norm(rowsumsa-row_pattern_sums(fullproduct,a)))
%
