%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% D-ILU: incomplete LU, updates only diagonal entries, right-looking version
%
  function [l,d,u]=d_ilu(a)

  [m n]=size(a);
  if(m ~= n) error; end 
  d=zeros(n,n);

  for k=1:n-1
    d(k,k)=a(k,k);
    for i=k+1:n
      if (a(i,k) ~= 0) 
         a(i,k)=a(i,k)*inv(a(k,k));
         for j=k+1:n
           if (a(k,j) ~= 0)
             if (a(i,j) ~= 0 && i==j) % the last condition means that only diagonal entries are updated
               a(i,j)=a(i,j)-a(i,k)*a(k,j);
             end
           end
         end % j
       end
     end % i
   end % k
   d(n,n)=a(n,n);
%
   l=tril(a);
   l=l-diag(diag(l))+eye(n);
   u=triu(a);
%
% preprocessing for LDU of the D-LU type
%

   l=l-eye(n);
   u=u-diag(diag(u)) + d;
   l=l*d;
   l=l+d;
