%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% get ILU pattern by levels using fast structural pass for rows of U and columns of L
%
  function [pattern]=get_ilu_pattern(a,ilev)

      [n n]=size(a);
      [ia,ja,aa]=a2csr(a);
      [iat,jat,aat]=a2csr(a');
      q=[];
      wn01=zeros(n+1,1);

      for i=1:n
        length(i)=0;
        visited(i)=0;
      end
      siz=0;
      for i=1:n
        ind2=ilukrows_fast(n,ia,ja,ilev,i,q,length,visited,wn01);
        siz=siz+ind2;
      end
      iq=zeros(1,n+1);jq=zeros(1,siz);
      siz=0;
      iq(1)=1;
      for i=1:n
        [siz,jq]=ilukrown_fast(n,ia,ja,ilev,i,q,length,visited,siz,jq);
        iq(i+1)=siz+1;
      end

      sizt=0;
      for i=1:n
        length(i)=0;
        visited(i)=0;
      end
      for i=1:n
        ind2=ilukrows_fast(n,iat,jat,ilev,i,q,length,visited,wn01);
        sizt=sizt+ind2;
      end 
      ipt=zeros(1,n+1);jpt=zeros(sizt,1);
      ipt(1)=1;
      sizt=0;
      for i=1:n
        length(i)=0;
        visited(i)=0;
      end
      jpt=[];
      for i=1:n
        [sizt,jpt]=ilukrown_fast(n,iat,jat,ilev,i,q,length,visited,sizt,jpt);
        ipt(i+1)=sizt+1;
      end 
      iq;
      jq;
      ll=cs2a(n,iq,jq);
      ipt;
      jpt;
      uu=cs2a(n,ipt,jpt);
      pattern=ll+uu';




      function ind2=ilukrows_fast(n,ia,ja,levels,vertex,q,length,visited,wn01)
%
      first=1;
      q(first)=vertex;
      last=first;
      ind2=0;
      ind2=ind2+1;
      visited(vertex)=vertex;
%
      ind1=0;
      for i=1:n
        if (first > last) break; end
        h=q(first);
        first=first+1;
        for ii=ia(h):ia(h+1)-1
          j=ja(ii);
          if (visited(j) == vertex) continue; end
          visited(j)=vertex;
          if (j < vertex && length(h) < levels)
            last=last+1;
            q(last)=j;
            length(j)=length(h)+1;
            ind1=ind1+1;
            wn01(ind1)=j;
          elseif(j >vertex) 
            ind2=ind2+1;
          end 
        end 
      end 
%
%  -- reset of flags
%
      for i=1:ind1
        j=wn01(i);
        length(j)=0;
      end 


      function [ind2,jp] =ilukrown_fast(n,ia,ja,levels,vertex,q,length,visited,ind2,jp)

      first=1;
      q(first)=vertex;
      last=first;
%
      ind2=ind2+1;
      jp(ind2)=vertex;
      visited(vertex)=-vertex;
%
      for i=1:n
        if(first > last) break; end
        h=q(first);
        first=first+1;
        for ii=ia(h):ia(h+1)-1
          j=ja(ii);
          if(visited(j) == -vertex) continue; end
          visited(j)=-vertex;
          if(j < vertex && length(h) < levels)
            last=last+1;
            q(last)=j;
            length(j)=length(h)+1;
          elseif(j > vertex) 
            ind2=ind2+1;
            jp(ind2)=j;
          end 
        end
      end

