%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% get pattern based on input type
%
%
  function [pattern] = get_pattern(a,pattern_type);
  %
  % basic initializations
  %
  [n,n] = size(a);
  pattern = zeros(n,n);
  %
  if(pattern_type == 0) % pattern of a
    pattern=a;
  elseif(pattern_type == 1) % LU (L+U pattern)
    [l u]=lu(sparse(a),0.0); 
    pattern=l+u;
  elseif(pattern_type == 2) % pattern of a squared input matrix
   pattern=a*a;
  elseif(pattern_type == 5) % diagonal
   pattern=eye(n);
  elseif(pattern_type == 10) % full pattern
    pattern=ones(n,n);
  end 
