%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% ILU: Crout version 
%
  function [l,u]=ilu_crout(a,tau)
%
  [m n]=size(a);
  if(m ~= n) error; end 
%
  for j=1:n
    l(j+1:n,j)=a(j+1:n,j); l(j,j)=1;
    u(j,j:n)=a(j,j:n);
    for k=1:j-1
      if(l(j,k) ~= 0) 
        u(j,j:n)=u(j,j:n)-l(j,k)*u(k,j:n);
      end  
    end
    for i=j+1:n
      if(abs(u(j,i)) < tau) u(j,i)=0; end
    end
    for k=1:j-1
      if(u(k,j) ~= 0) 
        l(j+1:n,j)=l(j+1:n,j)-u(k,j)*l(j+1:n,k);
      end  
    end
    % sparsify
    for i=j+1:n
      if(abs(l(i,j)) < tau) l(i,j)=0; end
    end
    l(j+1:n,j)=l(j+1:n,j)*inv(u(j,j));
   end % k
