%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% Fixed-point ILU based on an input pattern
%
  function [l,u]=ilu_fixed_point(a,atilde,pattern,nsweep)
%
  [n n]=size(a);
  l=zeros(n,n); u=zeros(n,n);
  for i=1:n
    for j=1:n
      if(atilde(i,j) ~= 0)
        if(i > j) 
          l(i,j)=atilde(i,j);
        elseif(i <= j)
          u(i,j)=atilde(i,j);
        end
      end
    end
    l(i,i)=1;
  end
%
  for i=1:nsweep
    for i=1:n
      for j=1:n
        if(pattern(i,j) ~= 0)
          if(i > j)
            temp=0;
            for k=1:j-1
              temp=temp+l(i,k)*u(k,j);
            end
            l(i,j) = (a(i,j) - temp)/u(i,i);
          else
            temp=0;
            for k=1:i-1
              temp=temp+l(i,k)*u(k,j);
            end
            u(i,j) = a(i,j) - temp;
          end 
        end
      end
    end
  end 
