%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% ILU based on a given pattern
%
  function [l,u]=ilu_pattern(a,pattern)

  [m n]=size(a);
  if(m ~= n) error; end 

  for k=1:n-1
    for i=k+1:n
      if (pattern(i,k) ~= 0) 
         a(i,k)=a(i,k)*inv(a(k,k));
         for j=k+1:n
           if (pattern(k,j) ~= 0)
             if (pattern(i,j) ~= 0)
               a(i,j)=a(i,j)-a(i,k)*a(k,j);
             end
           end
         end % j
       end
     end % i
   end % k
%
   l=tril(a);
   l=l-diag(diag(l))+eye(n);
   u=triu(a);
