%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% ILU by rows standard upward-looking version
%
  function [l,u]=ilu_rows(a,tau)
%
  [m n]=size(a);
  if(m ~= n) error; end 
  l=eye(n);
  u=zeros(n,n);
%
  for i=1:n
    w=a(i,1:n);
    u(i,i:n)=a(i,i:n);
    l(i,1:i-1)=a(i,1:i-1);
    for j=1:i-1
      if(abs(l(i,j)) < tau) l(i,j)=0; end
    end
    for j=i+1:n
     if(abs(u(i,j)) < tau) u(i,j)=0; end
    end
    for k=1:i-1
      w(k)=w(k)*inv(u(k,k));
      w(k+1:n)=w(k+1:n)-w(k)*u(k,k+1:n);
      l(i,k)=l(i,k)*inv(u(k,k));
      l(i,k+1:i-1)=l(i,k+1:i-1)-l(i,k)*u(k,k+1:i-1);
      for j=k:i-1
        if(abs(l(i,j)) < tau) l(i,j)=0; end
      end
      u(i,i:n)=u(i,i:n)-l(i,k)*u(k,i:n);
      for j=i+1:n
        if(abs(u(i,j)) < tau) u(i,j)=0; end
      end
    end
   end % i
