%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% ILU by levels
%
  function [l,u]=ilulevel2(A,ilev)
%
% assume SPD matrix A
%
  [n,n]=size(A);
%
% initialize levels
%
  a=A;
  for i=1:n
    for j=1:n
      level(i,j)=n+1;
    end
  end
  for i=1:n
    for j=1:n
      if(a(i,j) ~= 0) 
        level(i,j)=0;
      end
      if(i == j) 
        level(i,j)=0;
      end
    end
  end
%
% algorithm
%
  l=eye(n);
  u=zeros(n,n); 
  for i=1:n
    u(i,i:n)=a(i,i:n);
    l(i,1:i-1)=a(i,1:i-1);
    for k=1:i-1
      if(level(i,k) <= ilev)
        l(i,k)=l(i,k)*inv(u(k,k));
        for j=k+1:i-1
          l(i,j)=l(i,j)-l(i,k)*u(k,j);
          level(i,j)=min(level(i,j),level(i,k)+level(k,j)+1);
        end
        for j=i:n
          u(i,j)=u(i,j)-l(i,k)*u(k,j);
          level(i,j)=min(level(i,j),level(i,k)+level(k,j)+1);
        end
      end
    end
    for k=1:i-1
      if(level(i,k) > ilev)
        l(i,k)=0;
      end
    end
    for k=i:n
      if(level(i,k) > ilev)
        u(i,k)=0;
      end
    end
  end
%
