%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% nonsymmetric iterative refinement
%
  function [x]=iterative_refinement(A,L,U,b,nsteps)
%
  [n n]=size(A);
  P=eye(n); % not used here
%
  y=inv(L)*b; x=inv(U)*y;
  for i=1:nsteps
    r=b-A*x;
    y=inv(L)*r; dx=inv(U)*y;
    x=x+dx;
  end