%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% MILU: right looking version
% based on target sparsity pattern
%
  function [l,u]=milu(a,pattern)

  [m n]=size(a);
  if(m ~= n) error; end 
  l=tril(a)-diag(diag(a))+eye(n);u=triu(a);
  for k=1:n-1
    for i=k+1:n
      if (l(i,k) ~= 0) 
        l(i,k)=l(i,k)*inv(u(k,k));
         for j=i:n
           if (u(k,j) ~= 0)
             if (pattern(i,j) ~= 0)
               u(i,j)=u(i,j)-l(i,k)*u(k,j);
             else
               u(i,i)=u(i,i)-l(i,k)*u(k,j); 
             end
           end
         end % j
         for j=k+1:i-1
           if (u(k,j) ~= 0)
             if (pattern(i,j) ~= 0)
               l(i,j)=l(i,j)-l(i,k)*u(k,j);
             else
               u(i,i)=u(i,i)-l(i,k)*u(k,j);     
             end
           end
         end % j
       end
     end % i
   end % k
