%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% MILU(0): right looking version
%
  function [l,u]=milu0(a)

  [m n]=size(a);
  if(m ~= n) error; end 
  l=tril(a)-diag(diag(a))+eye(n);
  u=triu(a);
  for k=1:n-1
    for i=k+1:n
      if (a(i,k) ~= 0) 
         a(i,k)=a(i,k)*inv(a(k,k));
         for j=k+1:n
           if (a(k,j) ~= 0)
             if (a(i,j) ~= 0)
               a(i,j)=a(i,j)-a(i,k)*a(k,j);
             else
               a(i,i)=a(i,i)-a(i,k)*a(k,j);
             end
           end
         end % j
       end
     end % i
   end % k

   l=tril(a);
   l=l-diag(diag(l))+eye(n);
   u=triu(a);

