%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% MILU(0): right looking version
%
  function [l,u]=milu0a(a)

  [m n]=size(a);
  if(m ~= n) error; end 
  l=tril(a)-diag(diag(a))+eye(n);u=triu(a); % patterns that we will not use
  % test is on A and not on L and U (there can be some intermediate cancellation we want to avoid)
  for k=1:n-1
    for i=k+1:n
      if (l(i,k) ~= 0) 
        l(i,k)=l(i,k)*inv(u(k,k));
         for j=i:n
           if (u(k,j) ~= 0)
             if (a(i,j) ~= 0)
               u(i,j)=u(i,j)-l(i,k)*u(k,j);
             else
               u(i,i)=u(i,i)-l(i,k)*u(k,j); 
             end
           end
         end % j
         for j=k+1:i-1
           if (u(k,j) ~= 0)
             if (a(i,j) ~= 0)
               l(i,j)=l(i,j)-l(i,k)*u(k,j);
             else
               u(i,i)=u(i,i)-l(i,k)*u(k,j);     
             end
           end
         end % j
       end
     end % i
   end % k
