%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
%
% SOR iterative method
%

  function [x,relres,iter,info] = sor(a,rhs,omega,tol,maxit,x0)
%
  if nargin == 5, [n n]=size(a); x0=zeros(n,1); end
  if nargin == 4, [n n]=size(a); x0=zeros(n,1); maxit=1000; end
  if nargin == 3, [n n]=size(a); x0=zeros(n,1); maxit=1000; tol=1.0d-8; end
  if nargin == 2, [n n]=size(a); x0=zeros(n,1); maxit=1000; tol=1.0d-8; omega=1.0d0; end
  info=0; 
  iter=0;
  r=rhs-a*x0;
  rnorm=norm(r);
  rnorm0=rnorm;
  scaleda=a;
  x=zeros(n,1);
  d=diag(diag(a));l=-tril(a,-1);u=-triu(a,1);asor=(d-omega*l); % definitions for another variant
  for i = 1:n
%    scaleda(i,i) = 0; difference with respect to Gauss-Seidel
    x(i) = x0(i);
  end
  for i = 1:n
    scaleda(i,1:n) = scaleda(i,1:n)/a(i,i);
  end
  for i = 1:n
    scaledrhs(i) = rhs(i)/a(i,i);
  end
  iter = 0;
  while (iter < maxit) 
    xnew=x;
    xold=x;
    for i = 1:n
      delta(i) = scaledrhs(i)-scaleda(i,:)*xnew;
      xnew(i)=x(i)+omega*delta(i);
    end
    x=xnew;
    x = asor\(((1-omega)*d+omega*u)*xold)+omega*(asor\rhs); % the new variant (uses xold)
    iter = iter+1;
    rnorm=norm(rhs-a*x);
    fprintf('%s %d %s %1.8g \n','it = ',iter,' rnorm/rnorm0 = ',rnorm/rnorm0)
    if (rnorm <= tol*rnorm0)
      break; 
    end 
  end
  relres=rnorm/rnorm0;
 






