%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
%
% ldlt factorization by columns
% using block arithmetic
%
  function [l,d]=ldlt_columns(a)
%
  [m n]=size(a);
  aorg=a;
  l=eye(n);
  u=zeros(n,n);
  d=zeros(n,n);
  d(1,1)=a(1,1);
  u(1,1)=d(1,1);
  l(2:n,1)=a(2:n,1)/d(1,1);
  for j=2:n
    u(1:j-1,j)=inv(l(1:j-1,1:j-1))*a(1:j-1,j);
    z=a(j:n,j)-l(j:n,1:j-1)*d(1:j-1,1:j-1)*[l(j,1:j-1)]';
%    z=a(j:n,j)-l(j:n,1:j-1)*inv(d(1:j-1,1:j-1))*u(1:j-1,j);
    d(j,j)=z(1);
    u(j,j)=d(j,j);
    l(j+1:n,j)=z(2:n-j+1)/d(j,j);
  end
  %
  % checking definition of diagonal entries
  %
  norm(a-l*d*l');
  norm(a-l*u);
  norm(u-d*l');
  for j=1:n
    l(j,1:j)*d(1:j,1:j)*[l(j,1:j)]'-a(j,j);
  end
  for j=1:n
    sum=0;
    for k=1:j-1
      sum=sum+l(j,k)*d(k,k)*l(j,k);
    end
    djj2=a(j,j)-sum;
    djj=d(j,j);
    norm(djj-djj2);
  end
  for j=1:n
    v=zeros(n-j,1);
    for k=1:j-1
      v=v-l(j+1:n,k)*d(k,k)*l(j,k);
    end
    v1=a(j+1:n,j)+v;
    v2=l(j+1:n,j)*d(j,j);
    norm(v1-v2);
  end  




