
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% find strong diagonal
%
   function [rperm cperm scalr scalc]=find_strong_diagonal(a)
   %
   [m n] = size(a);
   if (m ~= n) stop_error; end
   [ia,ja,aa]=a2csr(a);
   ac=[];
   amax=zeros(1,n);
   for i=1:n
     jstrt=ia(i);
     jstop=ia(i+1)-1;
     for j=jstrt:jstop
       k=ja(j);
       amax(k)=max(amax(k),abs(aa(j)));
     end
   end
   for i=1:n
     jstrt=ia(i);
     jstop=ia(i+1)-1;
     for j=jstrt:jstop
       k=ja(j);
       ac(j)=-(log(amax(k))-log(abs(aa(j))));
      % it is negative since we look for minimum weight matching
     end
   end
   c=csr2a(n,ia,ja,ac);
   a
   c=full(c)
   
    %
    [rperm cperm u v srank]=bpmatch_a_la_mc64(n,n,ia,ja,ac)
    %
    % define scalings
    %
    c
    scalr=eye(n);
    for i=1:n
      scalr(i,i)=exp(-u(i));
    end
    scalc=eye(n);
    icperm=zeros(1,n);
    for j=1:n
      icperm(cperm(j))=j;
      scalc(j,j)=exp(-v(j))/amax(j);
    end
     P=zeros(n,n);
     for i=1:n
       P(cperm(i),rperm(i))=1; % this permutation matrix permutes columns
     end
     if(srank == n)
       c
       u
       v
       a
       a(rperm,cperm)
%       a*P % that would be without scaling, showing that the matching edges get to the diagonal
       scalr*abs(a)*scalc*P
     end
    
    
