%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% lu factorization by columns
% using block arithmetic (in description, not for efficiency)
%
  function [l,u]=lu_columns(a)
%
  [m n]=size(a);
  aorg=a;                                                                                                                                                                
  l=eye(n);
  l(2:n,1)=a(2:n,1)/a(1,1);
  u=zeros(n,n);
  u(1,1)=a(1,1);
  for j=2:n
    u(1:j-1,j)=inv(l(1:j-1,1:j-1))*a(1:j-1,j);
    z=a(j:n,j)-l(j:n,1:j-1)*u(1:j-1,j);
    u(j,j)=z(1);
    l(j+1:n,j)=z(2:n-j+1)/u(j,j);
  end
