%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% ijk lu decomposition:
% inner product row update algorithm
%
  function [l,u]=lu_ijk(m,n,a)
  aorg=a;
  l=eye(n);
  u=zeros(n,n);
  u(1,1:n)=a(1,1:n);
  for i=2:n
    for j=2:i
      l(i,j-1)=a(i,j-1)/a(j-1,j-1);
      for k=1:j-1
        a(i,j)=a(i,j)-l(i,k)*a(k,j);
      end
    end
    for j=i+1:n
      for k=1:i-1
        a(i,j)=a(i,j)-l(i,k)*a(k,j);
      end
    end
    u(i,i:n)=a(i,i:n);
  end
