%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% ijk/jik lu decomposition
% (inner-product) row/column bordering algorithm
%
  function [l,u]=lu_ijkjik(m,n,a)
  aorg=a;
  l=eye(n);
  u=zeros(n,n);
  u(1,1)=a(1,1);
  for i=2:n
    for j=2:i
      l(i,j-1)=a(i,j-1)/a(j-1,j-1);
      for k=1:j-1
        if i > j
          a(i,j)=a(i,j)-l(i,k)*a(k,j);
        end 
      end
    end
    for j=2:i
      for k=1:j-1
        a(j,i)=a(j,i)-l(j,k)*a(k,i);
      end
    end
    u(1:i,i)=a(1:i,i);
  end
