%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% ikj lu decomposition:
% (delayed) row update algorithm
%
  function [l,u]=lu_ikj(m,n,a)
  aorg=a;
  l=eye(n);
  u=zeros(n,n);
  u(1,1:n)=a(1,1:n);
  for i=2:n
    for k=1:i-1
      l(i,k)=a(i,k)/a(k,k);
      for j=k+1:n
        a(i,j)=a(i,j)-l(i,k)*a(k,j);
      end
    end
    u(i,i:n)=a(i,i:n);
  end
