%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% jki lu decomposition
% (delayed) column update algorithm
%
  function [l,u]=lu_jki(m,n,a)
  aorg=a;
  l=eye(n);
  u=zeros(n,n);
  u(1,1)=a(1,1);
  for j=2:n
    for s=j:n
      l(s,j-1)=a(s,j-1)/a(j-1,j-1);
    end
    for k=1:j-1
      for i=k+1:n
        a(i,j)=a(i,j)-l(i,k)*a(k,j);
      end
    end
    u(1:j,j)=a(1:j,j);
  end
