%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% jki/ikj lu decomposition
% (delayed) column/row bordering algorithm
%
  function [l,u]=lu_jkiikj(m,n,a)
  aorg=a;
  l=eye(n);
  u=zeros(n,n);
  u(1,1)=a(1,1);
  for s=2:n
    j=s;
    for k=1:j-2
      for i=k+1:j-1
        a(i,j)=a(i,j)-l(i,k)*a(k,j);
      end
    end
    for k=1:j-1
      l(j,k)=a(j,k)/a(k,k);
      for i=k+1:j
        a(j,i)=a(j,i)-l(j,k)*a(k,i);
      end
    end
    u(1:j,j)=a(1:j,j);
  end

