%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% kij lu decomposition:
% row-oriented outer product (submatrix) algorithm
%
  function [l,u]=lu_kij2(m,n,nsteps,A)
  a=A;
  %
  l=eye(n);
  u=zeros(n,n);
  for k=1:nsteps-1
    for i=k+1:m
      l(i,k)=a(i,k)/a(k,k);
      for j=k+1:n
        a(i,j)=a(i,j)-l(i,k)*a(k,j);
      end
    end
    u(k,k:n)=a(k,k:n);
  end
  u(nsteps,nsteps)=a(nsteps,nsteps);
  format long;
  norm(A-l*u);
