% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
%
% LU: right-looking semisparse version (kij)
%
  function [l,u]=lu_kij_semisparse(a)
%
  [m n]=size(a);
  l=tril(a)-diag(diag(a))+eye(n);u=triu(a);
  if(m ~= n) error; end 
  asave=a;
%
%  disp 'semisparse'
  for k=1:n-1
%    k
    for i=k+1:n
      l(i,k)=l(i,k)*inv(u(k,k));
    end
    for j=k+1:n
      l(j+1:n,j)=l(j+1:n,j)-u(k,j)*l(j+1:n,k);
    end
    for i=k+1:n
      u(i,i:n)=u(i,i:n)-l(i,k)*u(k,i:n);
    end
%    lpartial=l
%    upartial=u
  end % k

