%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% kji lu decomposition
% column-oriented outer product (submatrix) algorithm
%
  function [l,u]=lu_kji(m,n,a)
  aorg=a;
  format long;
  l=eye(n);
  u=zeros(n,n);
  for k=1:n-1
    for s=k+1:n
      l(s,k)=a(s,k)/a(k,k);
    end
    for j=k+1:n
      for i=k+1:n
        a(i,j)=a(i,j)-l(i,k)*a(k,j);
      end
    end
    u(k,k:n)=a(k,k:n);
  end
  u(n,n)=a(n,n);
