%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% convert matlab dense/sparse matrix into CSR
%
%  function [ia,ja,aa]=a2csr(a)
%
% purpose:
%   Convert any matrix into CSR
%
%
  function [ia,ja,aa]=a2csr(a)
  [m n]= size(a);
  aa=zeros(1,n);
%
  ind=1;
  ia(ind)=1; 
  for i=1:m
    for j=1:n
       if(a(i,j) ~= 0) 
         ja(ind)=j;
         aa(ind)=a(i,j);
         ind=ind+1;
       end
    end
    ia(i+1)=ind;
  end