%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% convert matlab sparse matrix into CSR
%
%  function [ia,ja,aa]=a2csr_sparse(a)
%
% purpose:
%   Convert a sparse matrix into CSR
%
  function [ia,ja,aa]=a2csr_sparse(a)
  [m n]= size(a);
  [row,col,val]=find(a);
%
  [nz nn]=size(row);
  ia=zeros(n+1,1);
  for k=1:nz
    i=row(k);
    ia(i+1)=ia(i+1)+1;
  end
  ia(1)=1;
  for i=2:n+1
    ia(i)=ia(i-1)+ia(i);
  end
%
  wn01(1:m)=ia(1:m);
  for k=1:nz
     i=row(k);
     ja(wn01(i))=col(k);
     aa(wn01(i))=val(k);
     wn01(i)=wn01(i)+1;
  end 
  %
  