%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% convert matlab dense/sparse matrix into CSR
%
%
%  convert CSR into matlab sparse matrix 
%
%  function [a]=csr2a(m,ia,ja,aa)
%
% purpose:
%
%   Convert CSR into a sparse matlab matrix
%
   function [a]=csr2a(m,ia,ja,aa)
%
%  find maximum column index
%
   jmax=0;
   for i=1:ia(m+1)-1
     jmax=max(jmax,ja(i));
   end

   n=jmax;
%
   a=sparse(m,n);
%   a=zeros(m,n);
   for i=1:m
     jstrt=ia(i);
     jstop=ia(i+1)-1;
     for j=jstrt:jstop
       a(i,ja(j))=aa(j);
     end
  end


