%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% equilibration scaling 
%
   %
   % find the scaling in infinite norm
   %
     function [sr,sc]=equilibration_scaling(a,nsteps,tol)
   %
     [n n]=size(a);
     B=a;D=eye(n);E=eye(n);
     ri=zeros(n,1); cj=zeros(n,1);
   %
     for l=1:nsteps
       for i=1:n
         ri(i)=norm(B(i,1:n),inf); 
         ritemp(i)=abs(1 -ri(i));
         cj(i)=norm(B(1:n,i),inf); 
         cjtemp(i)=abs(1 -cj(i));
       end
       maxr=max(ritemp(1:n));
       maxc=max(cjtemp(1:n));
       if(maxr <= tol && maxc <= tol) break; end
       R=diag(sqrt(ri(1:n)));
       C=diag(sqrt(cj(1:n)));
       B=inv(R)*B*inv(C);
       D=D*inv(R); E=E*inv(C);
     end
     sr=D;
     sc=E;