%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% generate block upper triangular matrix
%
  function [a,ptr] = gen_block_upper_triangular(nbl,density,maxblsize);
%
  value=1;
  counts=randi(maxblsize,nbl,1);
  ptr(1)=1;
  for i=2:nbl
    ptr(i)=ptr(i-1)+counts(i-1);
  end
  n=ptr(nbl)+counts(nbl)-1;
  ptr(nbl+1)=n+1;
  b=zeros(n,n);
  a=sprand(nbl,nbl,density) + eye(nbl); a=a+a';
  for i=1:nbl
    for j=1:nbl
      if (a(i,j) ~= 0 && i <= j) b=mapbl(i,j,ptr,counts,b,value); end
    end
  end
  a=b;

  function [b] = mapbl(i,j,ptr,counts,b,value)
  %
  b(ptr(i):ptr(i)+counts(i)-1,ptr(j):ptr(j)+counts(j)-1)=value;
  