%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% get matrix 

function [A,x,rhs,name]=getmat(matrix);
%
% get/read matrix
%
%
% spd matrices
%
format short
name='';
if(matrix == 1) 
  name='bcsstk06.mtx';
  fullname=strcat('./matrix/',name);
  A = mmread(fullname);
  [m,n]=size(A);
  x=[1:n]';
  rhs=A*x;
  x=A\rhs;
elseif(matrix == 2) 
  name='poisson';
  A=poisson(3);
  [m,n]=size(A);
  x=[1:n]';
  rhs=A*x;
  x=A\rhs;
elseif(matrix == 3) 
  name='bcsstk14.mtx';
  fullname=strcat('./matrix/',name);
  A = mmread(fullname);
  [m,n]=size(A);
  x=[1:n]';
  rhs=A*x;
  x=A\rhs;
elseif(matrix == 4) % od PT
  A = load('./matrix/peta/strakos24.matrix');
  A=spconvert(A);
  [n,n]=size(A);
  x = load('./matrix/peta/strakos24.x');
  rhs = load('./matrix/peta/strakos24.rhs');
  eigs = load('./matrix/peta/strakos24.eigs');
  x=A\rhs;
elseif(matrix == 5) % od PT
  A = load('./matrix/peta/strakos48.matrix');
  A=spconvert(A);
  [n,n]=size(A);
  x = load('./matrix/peta/strakos48.x');
  rhs = load('./matrix/peta/strakos48.rhs');
  eigs = load('./matrix/peta/strakos48.eigs');
  x=A\rhs;
elseif(matrix == 10) 
  A = mmread('./matrix/ex5.mtx');
  [n,n]=size(A);
  x=[1:n]';
  rhs=A*x
  x=A\rhs;
%
% nonsymmetric matrices
%
elseif(matrix == 30) 
  A = mmread('./matrix/saylr1.mtx');
  [n,n]=size(A);
  x=[1:n]';
  rhs=A*x
  x=A\rhs;
elseif(matrix == 35) % test matrix from Pan, Soleymani, Zhao, submitted to BIT
  A=zeros(12,12);
  A(2,1)=-2.;
  A(1,2)=4./10.;
  A(2,2)=4./10.;
  A(3,1)=-1.;
  A(3,2)=-1.;
  A(3,3)=1.;
  A(3,4)=-1.;
  A(3,9)=-1.;
  A(4,1)=-1.;
  A(4,2)=-1.;
  A(4,3)=-1.;
  A(4,4)=1.;
  A(5,5)=1.;
  A(5,6)=1.;
  A(5,7)=-1.;
  A(5,8)=-1.;
  A(5,11)=-1;
  A(6,5)=1.;
  A(6,6)=1.;
  A(6,7)=-1.;
  A(6,8)=-1.;
  A(7,4)=-1.;
  A(7,5)=-2.;
  A(7,6)=4./10.;
  A(8,5)=2.;
  A(8,6)=4./10.;
  A(9,2)=-1.;
  A(9,9)=1.;
  A(9,10)=-1.;
  A(9,11)=-1.;
  A(9,12)=-1.;
  A(10,9)=-1.;
  A(10,10)=1.;
  A(10,11)=-1.;
  A(10,12)=-1.;
  A(11,11)=4./10.;
  A(11,12)=-2.;
  A(12,11)=4./10.;
  A(12,12)=2.;
  n=12;
  A=full(A);
  x=[1:n]';
  rhs=A*x
%
% rectangular matrices (tall)
%
elseif(matrix == 50)
  a=poisson(3);
  a=poisson(2);  
  [n,n]=size(a);
  a(n+1:2*n,1:n)=a;
  m=2*n;
  A=full(a);
  x=[1:n]';
  rhs=A*x
elseif (matrix == 51) 
  m=8;
  n=4;
  A=rand(m,n);
  x=[1:n]';
  rhs=A*x
elseif (matrix == 52) 
  poiss
  x=[1:n]';
  rhs=A*x
elseif (matrix == 53) 
%  A = mmread('./matrix/bcsstk06.mtx');
%  A = mmread('./matrix/lp_osa_07.mtx');
  A = mmread('./matrix/well1033.mtx');
  A = mmread('./matrix/bcsstk01.mtx');
  A=0.0000001*A;
  m=14
  n=8
  A=A(1:m,1:n);
  x=[1:n]';
  rhs=A*x
elseif (matrix == 54) 
  m=20;
  n=10;
  A=rand(m,n);
  x=[1:n]';
  rhs=A*x
elseif(matrix == 55) % 
  m=7;
  n=4;
  ne=11;
  A=[4 -1 -1 0; -1 4 0 -1; -1 0 4 -1; 0 -1 -1 4];
  A=zeros(m,n);
  A(1,1)=3;
  A(6,1)=2;
  A(7,1)=6;
  A(2,2)=2;
  A(4,2)=4;
  A(6,2)=1;
  A(3,3)=1;
  A(5,3)=5;
  A(7,3)=1;
  A(4,4)=2;
  A(7,4)=2;
  x=[1:n]';
  rhs=A*x
%
% rectangular matrices (fat)
%
elseif(matrix == 75) %  
  m=4;
  n=7;
  ne=11;
  A=[4 -1 -1 0; -1 4 0 -1; -1 0 4 -1; 0 -1 -1 4];
  A=zeros(n,m);
  A(1,1)=3;
  A(6,1)=2;
  A(7,1)=6;
  A(2,2)=2;
  A(4,2)=4;
  A(6,2)=1;
  A(3,3)=1;
  A(5,3)=5;
  A(7,3)=1;
  A(4,4)=2;
  A(7,4)=2;
  A=A';
  x=[1:n]';
  rhs=A*x
elseif(matrix == 76) %  first test for ls
  a=poisson(3);
  a=poisson(2);  
  [n,n]=size(a);
  a(n+1:2*n,1:n)=a;
  m=2*n;
  A=full(a);
  rhs=ones(m,1);
  x = A \ rhs;
elseif(matrix == 77) %  second test for ls
  m=200;
  n=80;
  A=rand(m,n);
  rhs=ones(m,1);
  x = A \ rhs;
elseif(matrix == 78) %  third test for ls
  m=8;
  n=4;
  nz=32;
  A=[10 1 2 3;   1 10 2 3;  1 1 10 1;  1 1 1 10; 10 1 2 3;  1 10 2 3;  1 1 17 1;  1 3 5 10];
  rhs=[1 2 3 4 1 2 3 4]';
  x = A \ rhs;
elseif (matrix == 79) 
%    a = mmread('./bcsstk06.mtx');
%    a = mmread('./lp_osa_07.mtx');
%    a = mmread('./matrix/well1033.mtx');
  a = mmread('./matrix/bcsstk01.mtx');
  a=0.0000001*a;
  m=39
  n=10
  A=a(1:m,1:n);
  rhs=ones(m,1);
  x = A \ rhs;
elseif (matrix == 80) 
  m=7;
  n=4;
  ne=11;
  A=[4 -1 -1 0; -1 4 0 -1; -1 0 4 -1; 0 -1 -1 4];
  A=zeros(m,n);
  A(1,1)=3;
  A(6,1)=2;
  A(7,1)=6;
  A(2,2)=2;
  A(4,2)=4;
  A(6,2)=1;
  A(3,3)=1;
  A(5,3)=5;
  A(7,3)=1;
  A(4,4)=2;
  A(7,4)=2;
  x=[1:n]';
  rhs=A*x
  rhs=ones(m,1);
elseif (matrix == 81)
%  load('jen1')
  load('jen2')
  A=spconvert(jen2)
  A=A';  
  [m n]=size(A);
  x=[1:n]';
  rhs=ones(m,1);
%
% general indefinite systems
%
elseif(matrix == 200) % 
  A=poisson(10);
  [n,n]=size(A)
  A=A-5*eye(n);
  eig(full(A));
  x=[1:n]';
  rhs=A*x;
end
%
  