%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% simple CSR-CSC matrix-matrix multiplication
%
   % standard slow
   % ia,ja,aa by rows
   % ib,jb,ab by columns
   %
    function [id,jd,ad]=matmat0(ma,na,ia,ja,aa,mb,nb,ib,jb,ab)
   %
     if (na ~= mb) err; end
   %
     nemax=0;
     for i=1:ma
       nemax=max(nemax,ia(i+1)-ia(i));
     end
     arrayi=zeros(nemax,1);
     arrayr=zeros(nemax,1);
     %
     id(1)=1;
     indd=0; 
     for i=1:ma
       na=ia(i+1)-ia(i);
       ind=0;
       for j=ia(i):ia(i+1)-1
          k=ja(j);
          ind=ind+1;
          arrayi(ind)=k; 
          arrayr(ind)=aa(j);
       end 
       lena=ind;
       for j=1:nb
         lenb=ib(j+1)-ib(j);
         temp=multvec(lena,arrayi,arrayr,lenb,jb(ib(j):ib(j+1)-1),ab(ib(j):ib(j+1)-1));
         if(temp ~= 0) 
           indd=indd+1;
           jd(indd)=j;
           ad(indd)=temp;
         end
       end
       id(i+1)=indd+1;
     end
   %
