%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% CSR-CSR matrix-matrix addition
%
   %
    function [ic,jc,ac]=mmadd(m,n,alpha,ia,ja,aa,bet,ib,jb,ab)
   %
   %
    ic(1)=1;
    ind=0;
    wn01=zeros(n,1);
    for i=1:m
      ind2=0;
      for j=ia(i):ia(i+1)-1
        k=ja(j);
        ind2=ind2+1;
        wn02(ind2)=k;
        wn01(k)=ind2;
        wr02(ind2)=alpha*aa(j);
      end
      for j=ib(i):ib(i+1)-1
        k=jb(j);
        if(wn01(k) == 0) 
          ind=ind+1;
          jc(ind)=k;
          ac(ind)=bet*ab(j);
        else
          ind=ind+1;
          ac(ind)=bet*ab(j)+wr02(wn01(k));
          wr02(wn01(k))=0;
          jc(ind)=k;
        end
      end
      for j=ia(i):ia(i+1)-1
        k=ja(j);
        if(wr02(wn01(k)) ~= 0)
          ind=ind+1;
          jc(ind)=k;
          ac(ind)=wr02(wn01(k));
        end
        wn01(k)=0;  
      end
      ic(i+1)=ind+1; 
    end
   %
