% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% get symmetry index of a matrix in CSR format


  function [sindex,assindex]=symmetry_index_CSR(csra,csrat);

  n=csra.nrows;
  symmetric_part=0;
  antisymmetric_part=0;
  ne=0;
  sindex=0;
  [ias,jas,aas]=mmadd(n,n,1,csra.ia,csra.ja,csra.aa,-1,csrat.ia,csrat.ja,csrat.aa); % antisymmmetric part
  [is,js,as]=mmadd(n,n,1,csra.ia,csra.ja,csra.aa,1,csrat.ia,csrat.ja,csrat.aa); % symmmetric part
  for i=1:n
    for j=ias(i):ias(i+1)-1
      k=jas(j);
      antisymmetric_part=antisymmetric_part+abs(aas(j));
    end 
  end
  antisymmetric_part=antisymmetric_part/2;
  for i=1:n
    for j=is(i):is(i+1)-1
      k=js(j);
      symmetric_part=symmetric_part+abs(as(j));
    end 
  end
  symmetric_part=symmetric_part/2;
  assindex=double(antisymmetric_part)/max(1,double(symmetric_part));
  for i=1:n
    for j=csra.ia(i):csra.ia(i+1)-1
      csra.aa(j)=1;
      if(i ~= csra.ja(j)) ne=ne+1; end
    end 
  end
  for i=1:n
    for j=csrat.ia(i):csrat.ia(i+1)-1
      csrat.aa(j)=1;
    end 
  end
  sindex=0;
  [ias,jas,aas]=mmadd(n,n,1,csra.ia,csra.ja,csra.aa,-1,csrat.ia,csrat.ja,csrat.aa); % symmmetric part
  for i=1:n
    for j=is(i):is(i+1)-1
      if(abs(aas(j)) == 0 && i~=jas(j)) sindex=sindex+1; end
    end 
  end
  sindex=sindex/max(1,ne);
%



