%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% sparse matrix transposition 
%
   %
   % transpose a matrix in CSR format
   %
     function [ib,jb,ab]=trancs(m,n,ia,ja,aa)
   %
     count=zeros(n,1);
     ne=0;
     for i=1:m
       for j=ia(i):ia(i+1)-1
         k=ja(j);
         count(k)=count(k)+1;
         ne=ne+1;
       end
     end
   %
     ib=zeros(n+1,1);
     jb=zeros(ne,1);
     ab=zeros(ne,1);
     ib(1)=1;
     for i=2:n+1
       ib(i)=ib(i-1)+count(i-1);
     end
   %
     count=ib;
     for i=1:m
       for j=ia(i):ia(i+1)-1
         k=ja(j);
         point=count(k); 
         jb(point)=i;
         ab(point)=aa(j);
         count(k)=count(k)+1;
       end
     end
    %
