%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% Truncated Neumann series preconditioner
% Of course, this type of routines is only to check correctness for very small problems
% and to show algorithms. Such preconditioners CANNOT be computed explicitly.
%
  function [minv]=truncated_neumann(a,omega,mbar,k)

  [n n]=size(a);


  c=eye(n)-omega*inv(mbar)*a;
  rho=spectral_radius(c);
  while rho > 1
    omega=0.9*omega;
    c=eye(n)-omega*inv(mbar)*a;
    rho=spectral_radius(c);
  end
  sum=eye(n);
  power=eye(n);
  for j=1:k
    power=power*c;
    sum=sum+power;
  end
  minv=omega*power*inv(mbar);


  function rho=spectral_radius(a);

  rho=max(abs(eig(a)));
