%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
        %
        % find a pseudoperipheral vertex
        %
        function [start,nlvl,xls,ls]=find_pseudoperipheral(start,n,ia,ja,mask)
         [nlvl,xls,ls]=bfs_connected_masked(n,ia,ja,start,mask);
         nprevious_lvl=nlvl+1;
         count=0;
         if (nlvl > 1 && nlvl < xls(nlvl+1)-1) 
           while (nlvl < xls(nlvl+1)-1 || nprevious_lvl > nlvl) % should run at least once
             count=count+1;
             if(count > 1) nlvl=nprevious_lvl; end
             jstrt=xls(nlvl);
             minimum_degree_neighbor=n;
             start=ls(jstrt);
             if (jstrt < xls(nlvl+1)-1)  % at least two vertices in the last level 
                                         % find its degree among unmasked vertices
                for j=jstrt:xls(nlvl+1)-1 % last level
                   node=ls(j);
                   degree=0;
                   kstrt=ia(node);
                   kstop=ia(node+1) - 1;
                   for k=kstrt:kstop
                     if (mask(ja(k)) >  0)  
                       degree=degree+1; 
                     end
                   end
                   if (degree < minimum_degree_neighbor)  
                     start=node;
                     minimum_degree_neighbor=degree;
                   end
                 end 
             end
             [nprevious_lvl,xls,ls]=bfs_connected_masked(n,ia,ja,start,mask);
             if (nprevious_lvl <= nlvl) break; end
           end 
         end



