%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
%
      function [p,q] = get_perm_sbbd(n,rowblock,columns)
%
      nblocks=0;
      counts=zeros(1,n);
      %
      % row permutation
      %
      for i=1:n
        j=rowblock(i);
        if (j > nblocks) nblocks=j; end
        counts(j)=counts(j)+1;
      end
      ptrrow(1)=1;
      for i=1:nblocks
        ptrrow(i+1)=ptrrow(i)+counts(i);
      end
      ptrrow(nblocks+1);
      for i=1:n
        j=rowblock(i);
        p(ptrrow(j))=i;
        ptrrow(j)=ptrrow(j)+1;
      end
      counts(1:nblocks)=zeros(1,nblocks);
      %
      % column permutation
      %
      nsep=0;
      for i=1:n
        j=columns(i);
        if (j <= n) 
          counts(j)=counts(j)+1;
        else 
          nsep=nsep+1;
        end 
      end
      ptrcol(1)=1;
      for i=1:nblocks
        ptrcol(i+1)=ptrcol(i)+counts(i);
      end
      for i=1:n
        j=columns(i);
        if (j <= n) 
          q(ptrcol(j))=i;
          ptrcol(j)=ptrcol(j)+1;
        else
          q(ptrcol(nblocks+1))=i;
          ptrcol(nblocks+1)=ptrcol(nblocks+1)+1;
        end
      end
