%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% Get single bordered form
%
      function [rowblock,columns] = get_sbbd(n,ib,jb,ia,ja,iat,jat,vs,nvs)
%
      rowblock=zeros(1,n);
      columns=zeros(1,n);
      %
      % denote separator nodes
      %
      for col=1:nvs
        j=vs(col);
        columns(j)=n+1; % mark separator nodes
      end  
      nvs;
      vs;
      %
      % find components
      %
      icomp=0;
      for col=1:n
        col;
        if (columns(col) == 0) % vertex does not belong to the separator or some previously marked component
          icomp=icomp+1; % find next component in graph of a+a'
          [scomp,comp,columns]=find_component(col,icomp,n,ib,jb,columns);
        end
      end
      ncomp=icomp; % number of components of the 
      %
      counts=zeros(1,n);
      for row=1:n  % for each row
        row;
        % compute nikb
        for j=ia(row):ia(row+1)-1
           k=ja(j);
           colk=columns(k);
           if(colk <= n)
             counts(colk)=counts(colk)+1;
           end
        end
        imax=0;temp=0;
        for j=ia(row):ia(row+1)-1
           k=ja(j);
           colk=columns(k);
           if(colk <= n)
             if(counts(colk) > temp)
               temp=counts(colk);
               imax=colk;
             end
           end
           counts(colk)=0; 
         end
         if(imax ~= 0) 
           rowblock(row)=imax;
         end
         columns;
         for j=ia(row):ia(row+1)-1
           k=ja(j);
           if(columns(k) ~= 0 && columns(k) < n+1 && columns(k) ~= imax) % is in a different component
             columns(k)=n+1;
             nvs=nvs+1;
             vs(nvs)=k;
           end
         end
%         if(row == 7) imax, columns, temp, rowblock,  huhu, end
      end
      next=1;
      icomp=1; % distribute cyclically among rows
      for row=1:n
        if(rowblock(row) ==0) 
          rowblock(row)=icomp;
        end
        icomp=icomp+1;
        if(icomp > ncomp) icomp=1; end 
      end 
      for i=1:nvs % loop of current separator nodes
        j=vs(i);
        temp=columns(ja(ia(j)));
        thesame=1;
        for jj=ia(j):ia(j+1)-1
          k=ja(jj);
          if(columns(k) ~= temp)
            thesame = 0;
          end  
        end
        if(thesame == 1)   % put j from separator into some group
          columns(j)=temp;
          vs(i)=0;
        end
      end
