%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
       function [perm,mask]=rcm(start,n,ia,ja,mask,component_size,perm,deg,mode)
       %
       % perm on input contains all nodes of all levels. level by level.
       %
       mask(start)=0;   % masking nodes as we go
       if (component_size > 1) 
         istop=0;
         newl_stop=1;
         while (newl_stop > istop)
           istrt=istop+1;
           istop=newl_stop;
           for i=istrt:istop
             newl_strt=newl_stop+1;
             node=perm(i);
             jstrt=ia(node);
             jstop=ia(node+1)-1;
             for j=jstrt:jstop % find nodes in the new level
                               % sort them ascendingly by their degrees
               nbr=ja(j);
               if (mask(nbr) ~= 0) 
                 newl_stop=newl_stop+1;
                 mask(nbr)=0;
                 perm(newl_stop)=nbr;
               end
             end
             seq=perm(newl_strt:newl_stop); 
             val=deg(seq); 
             [ss,p]=sort(val);
             sorted_seq=seq(p);
             perm(newl_strt:newl_stop)=sorted_seq;
           end
         end
       elseif (component_size == 1)
         mask(start)=0;
         newl_stop=1;
         perm(newl_stop)=start;
       end
       if (mode == 0) % RCM 
         pp=reverse_array(component_size,perm(1:component_size)); % not in-place -- I do not like it in Matlab
         perm(1:component_size)=pp;
       elseif(mode == 1) % CM
       else % error (in Matlab we do not need to catch all errors
       end






