%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% Note that the codes are prepared to teach and explain. Some parts are made
% INTENTIONALLy in a lazy way and may not be efficient.
% Much more care has been given to the SPARSLAB implementations in Fortran.
% CM/RCM reordering
%
% This implementation follows in more parts the approach by George and LIu 
% Named to honor their excellent contributions, some of them summarized in their 1981 book.
%
%    mode: =0 RCM
%          =1 CM
  
     function [perm] = rcm_gl(start,n,ia,ja,mode)
     %
     mask=ones(1,n);
     [deg no_unmasked]=get_degrees(n,ia,ja,mask); % compute degrees globally
     ind=1;
     perm=zeros(1,n);
     oldind=1;
     icomp=0;   % counter of graph components
     for i=1:n
       if (mask(i) ~= 0)
         start=i;
         icomp=icomp+1;
         %
         % find a pseudoperipheral vertex
         %
         [start,nlvl,xls,ls]=find_pseudoperipheral(start,n,ia,ja,mask);
         component_size=xls(nlvl+1)-1;
         [pp,mask]=rcm(start,n,ia,ja,mask,component_size,ls,deg,mode); % mask is updated here, not above
         perm(oldind:oldind+xls(nlvl+1)-1-1)=pp(1:xls(nlvl+1)-1);
         ind=oldind+xls(nlvl+1)-1;
         oldind=ind;
         if (ind > n) break; end
       end
      end



