%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% back solve, lower triangle by columns
%
  function [x] = bsolve_CSC(csra,b)
  %
  % diagonal entries are first in columns
  %
  n=csra.nrows; x=zeros(n,1);
  for i=n:-1:1
    jstrt=csra.ia(i);
    jstop=csra.ia(i+1)-1;
    for j=jstrt+1:jstop
      k=csra.ja(j);
      b(i)=b(i)-csra.aa(j)*x(k);
    end
    x(i)=b(i)/csra.aa(jstrt);
  end  

