%
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% forward solve, lower triangle by columns
%
  function [x] = fsolve_CSC(csra,b)
  %
  % diagonal entries are first in columns
  %
  n=csra.nrows; x=zeros(n,1);
  for i=1:n
    jstrt=csra.ia(i);
    jstop=csra.ia(i+1)-1;
    x(i) = b(i)/csra.aa(jstrt);
    for j=jstrt+1:jstop
      k=csra.ja(j);
      b(k)=b(k)-csra.aa(j)*x(i);
    end
  end  

