
%
% Miroslav Tuma, Charles University: Codes for Sparse matrices in Numerical Methods
% solve system in block upper triangular form
%
    function [x] = solve_block_upper_triangular(nbl,ptrb,a,b)
    %
    [n n]=size(a);
    x=zeros(n,1);
    for ib=nbl:-1:1
      ibsize=ptrb(ib+1)-ptrb(ib)
      s=b(ptrb(ib):ptrb(ib)+ibsize-1)
      for jb=ib+1:nbl
        jbsize=ptrb(jb+1)-ptrb(jb);
        s=s-a(ptrb(ib):ptrb(ib)+ibsize-1,ptrb(jb):ptrb(jb)+jbsize-1)*x(ptrb(jb):ptrb(jb)+jbsize-1)
      end
      diagbl=a(ptrb(ib):ptrb(ib)+ibsize-1,ptrb(ib):ptrb(ib)+ibsize-1);
      l=tril(diagbl)-diag(diag(diagbl))+eye(ibsize); u=triu(diagbl)
      y=inv(l)*s;
      x(ptrb(ib):ptrb(ib)+ibsize-1)=inv(u)*y;
    end