%
% driver for the course: Sparse matrices in Numerical Mathematics
% Miroslav Tuma
%
clear all
clc
path(path,'.\___chapters')
path(path,'.\__ai')
path(path,'.\__arrays_sets')
path(path,'.\__mrm')
path(path,'.\__basic')
path(path,'.\__blocks')
path(path,'.\__cholesky_sparse')
path(path,'.\__cholesky_factorization_phase')
path(path,'.\__graph')
path(path,'.\__ic')
path(path,'.\__import')
path(path,'.\__ilu')
path(path,'.\__io')
path(path,'.\__iter')
path(path,'.\__ldlt')
path(path,'.\__lu')
path(path,'.\__matrix')
path(path,'.\__matrix_data')
path(path,'.\__polynomial')
path(path,'.\__reorderings')
path(path,'.\__solve')
path(path,'.\__qr')
path(path,'.\__vector')
  % 
  % some settings
  %
  figures=1; % figures allowed
  never=0; % used to suppress running a branch
  %
%
% get the test matrix
%
  rng('default');
%  rng(2,'twister')
  chapter=1
  if(chapter == 1) % intro, direct methods
    chapter_1_introduction_sparse_matrices
  elseif(chapter == 2) % sparse matrices and their graphs
    chapter_2_graphs
  elseif(chapter == 3) % factorizations
    chapter_3a_factorizations 
  elseif(chapter == 30) % reducibility and blocks
     chapter_3b_reducibility_and_blocks
  elseif(chapter == 4) % sparse Cholesky symbolic
     chapter_4_symbolic_cholesky
  elseif(chapter == 5) % sparse Cholesky - factorization phase
     chapter_5_factorization_cholesky
  elseif(chapter == 6) % LU
     chapter_6_sparse_lu
  elseif(chapter == 7) % stability, ill-conditioning etc.
     chapter_7_stability_ill_conditioning
  elseif(chapter == 8) % reordering
     chapter_8_reorderings
  elseif(chapter == 9)
     chapter_9_algebraic_preconditioning
  elseif(chapter == 10)
     chapter_10_incomplete_factorizations
  elseif(chapter == 11) % approximate inverse preconditioners
    chapter_11_sparse_approximate_inverses
  elseif(chapter == 100) % QR (zatim spatne)
    %
    % Givens rotations
    %
    a=[10 1 1 1 ; 1 9 1 1; 1 1 8 1; 1 1 1 7]
    [m,n]=size(a)
    b=a*ones(n,1)
    [q r]=igo(a)
    a
    q*r
    huhu

  end

  disp 'finished' 

